unit Thread_RunCaption;

interface

uses
  Windows, Classes;

type
  TThreadRunCapture = class(TThread)
  private
    { Dclarations prives }
  protected
    procedure Execute; override;
  end;

implementation

uses
  Main, DataRecord, ChartSeries;


{ Important : les mthodes et les proprits des objets dans la VCL ne peuvent
  tre utilises que dans une mthode appele en utilisant Synchronize, par exemple :

      Synchronize(UpdateCaption);

  o UpdateCaption pourrait tre du type :

    procedure TThreadRunCapture.UpdateCaption;
    begin
      Form1.Caption := 'Mis  jour dans un thread';
    end; }

{ TThreadRunCapture }

procedure TThreadRunCapture.Execute;
var
  T0, T1, iInterval: integer;
begin

  iInterval := UserPrefs.CaptureInterval;  // in millisecondes

  // erase actual values ?
  if UserPrefs.ChartClearAtStartOfCapture then begin
    Chart_CheckForSave;
    Chart_Clear;
  end;

  // add active points on each enabled input to mark start of capture
  if UserPrefs.ChartInsertMarkerOnStartCapture then
    Chart_InsertStartMarker;

  // reset variables used for autorecord on disk
  with AutoRecordToDisk do begin
    RecordInProgress := false;
    CountFromStartOfFirstAlarm := 0;
    CountFromEndOfLasttAlarm := 0;
  end;

  ActualDataModified := true;

  // read in loop
  repeat

    T0 := GetTickCount;

    fmMain.MoveCaptureCursor;

    fmMain.Data_ReadValues;    // read from port
    fmMain.Data_AddToChart;    // refresh graph with new values
    fmMain.Data_Interpretate;  // check for alarms
    Data_RecordToFile;  // check for save datas to disk

    T1 := GetTickCount;
    //statusBar1.Panels[sbIdxRecordStatus].text := format('%d ms', [T1 - T0]);
    repeat
      T1 := GetTickCount;
    until (T1 - T0) > iInterval;

  until StopRequest;
end;

end.
