unit frmInputConfig;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, ToolWin, IniFiles, Buttons,
  rmCommutator, Menus, lmdstdcA, lmdcombo, lmdextcS;

type
  TfmInputConfig = class(TForm)
    Panel1: TPanel;
    lblGroupA2: TLabel;
    rmCommutator1: TrmCommutator;
    lblGroupA1: TLabel;
    lblGroupD2: TLabel;
    lblGroupD3: TLabel;
    lblGroupD4: TLabel;
    lblGroupA3: TLabel;
    lblGroupA4: TLabel;
    lblGroupD1: TLabel;
    lblInput01: TLabel;
    lblInput02: TLabel;
    lblInput03: TLabel;
    lblInput04: TLabel;
    lblInput05: TLabel;
    lblInput06: TLabel;
    lblInput07: TLabel;
    lblInput08: TLabel;
    edGroupCaption: TEdit;
    MainMenu1: TMainMenu;
    Fichier1: TMenuItem;
    mnuClose: TMenuItem;
    Edition1: TMenuItem;
    mnuCopy: TMenuItem;
    mnuPaste: TMenuItem;
    lblInput09: TLabel;
    lblInput10: TLabel;
    lblInput11: TLabel;
    lblInput12: TLabel;
    lblInput13: TLabel;
    lblInput14: TLabel;
    lblInput15: TLabel;
    lblInput16: TLabel;
    cbInputEnabled: TCheckBox;
    lblInputActive1: TLabel;
    pnlInput: TPanel;
    pnlStatus: TPanel;
    Label25: TLabel;
    Label1: TLabel;
    edActualStatus: TEdit;
    rbNominalStateOFF: TRadioButton;
    rbNominalStateON: TRadioButton;
    pnlValues: TPanel;
    Label4: TLabel;
    Label24: TLabel;
    Label3: TLabel;
    edMaxLimit: TEdit;
    edMinLimit: TEdit;
    edActualValue: TEdit;
    lblRowIndex: TLabel;
    Label7: TLabel;
    Label6: TLabel;
    edInputCaption: TEdit;
    btnCancel: TBitBtn;
    btnOK: TBitBtn;
    btnApply: TSpeedButton;
    btnRestore: TSpeedButton;
    lblInputActive2: TLabel;
    Label8: TLabel;
    edColor: TLMDColorComboBox;
    Label9: TLabel;
    btnReadActualState: TSpeedButton;
    btnReadActualValue: TSpeedButton;
    cbStartAlarmEnabled: TCheckBox;
    lblcbStartAlarmEnabled: TLabel;
    cbEndAlarmEnabled: TCheckBox;
    lblcbEndAlarmEnabled: TLabel;
    Bevel1: TBevel;
    edAlarmeState: TEdit;
    edCANFullScaleValue: TEdit;
    Label2: TLabel;
    Label5: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure edGroupCaptionChange(Sender: TObject);
    procedure rmCommutator1Change(Sender: TObject);
    procedure mnuCloseClick(Sender: TObject);
    procedure mnuCopyClick(Sender: TObject);
    procedure mnuPasteClick(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure btnApplyClick(Sender: TObject);
    procedure btnRestoreClick(Sender: TObject);
    procedure btnReadActualValueClick(Sender: TObject);
  private
    { Dclarations prives }
    GroupIndex, InputIndex: integer;
    SelectedInputIndex: integer;
    ReadDataInProgress: boolean;
    procedure GetParameters(SelInputIdx: integer);
    procedure SetParameters(SelInputIdx: integer);
    function InputAvailable(Idx: integer): boolean;
    procedure SetInitialInputSelection;
    procedure UnderlineInputSelection(iGroupIndex, iInputIndex: integer);
  public
    { Dclarations publiques }
  end;

var
  fmInputConfig: TfmInputConfig;

implementation

uses
  ResStr,
  rmMisc,
  uChartSeries,
  frmMain;

{$R *.DFM}


procedure TfmInputConfig.FormCreate(Sender: TObject);
begin
  ReadDataInProgress := false;
  SetInitialInputSelection;
  //SelectedInputIndex := 64;
end;

procedure TfmInputConfig.SetInitialInputSelection;
begin
  rmCommutator1.SwitchIndex := 0;  // simulation
  rmCommutator1Change(nil);
  edGroupCaptionChange(cbInputEnabled);
end;

procedure TfmInputConfig.rmCommutator1Change(Sender: TObject);
var
  WasChanged: boolean;
begin
  WasChanged := ActualConfigModified;
  GroupIndex := rmCommutator1.selectedLine; // 0..7
  InputIndex := rmCommutator1.selectedRow;  // 0 to 15
  case GroupIndex of
    0..3 : lblRowIndex.Caption := format('A%d', [GroupIndex + 1]);
    4..7 : lblRowIndex.Caption := format('D%d', [GroupIndex - 4 + 1]);
  end;
  //lblLineIndex.Caption := intToStr(InputIndex + 1);
  SelectedInputIndex := (16 * GroupIndex) + InputIndex;
  UnderlineInputSelection(GroupIndex, InputIndex);
  GetParameters(SelectedInputIndex);
  InputAvailable(SelectedInputIndex);
  if not WasChanged then
    ActualConfigModified := false;
end;

procedure TfmInputConfig.UnderlineInputSelection(iGroupIndex, iInputIndex: integer);
var
  i, iTag: integer;
  iGrp, iIn: integer;
  sName: string;
begin
  for i := 0 to pred(ComponentCount) do begin
    if not (components[i] is TLabel) then
      continue;
    sName := (components[i] as TLabel).name;
    sName := upperCase(copy(sName, 1, 8));
    if (sName = 'LBLGROUP') or (sName = 'LBLINPUT') then begin
      iTag := (components[i] as TLabel).tag;
      if not(((iTag > 1000) and (iTag < 1009)) or
             ((iTag > 2000) and (iTag < 2017))) then
        continue;
      iGrp := 1000 + iGroupIndex + 1;
      iIn := 2000 + iInputIndex + 1;
      if (iTag = iGrp) or (iTag = iIn) then begin
        (components[i] as TLabel).font.Style := (components[i] as TLabel).font.Style + [fsBold];
        (components[i] as TLabel).font.Color := clBlue;
      end else begin
        (components[i] as TLabel).font.Style := (components[i] as TLabel).font.Style - [fsBold];
        (components[i] as TLabel).font.Color := clBlack;
      end;
    end;
  end;
end;

function TfmInputConfig.InputAvailable(Idx: integer): boolean;
var
  InputAvail: boolean;
  AInStart, AInStop, DInStart, DInStop: integer;
begin

  // input available ?
  fmMain.HWInterface_GetValidInputs(AInStart, AInStop, DInStart, DInStop);
  InputAvail := fmMain.HWInterface_InputIsHandled(idx, AInStart, AInStop, DInStart, DInStop);

  cbInputEnabled.Enabled := InputAvail;
  //edInputCaption.enabled := InputAvail;
  //edInputCaption.Color := boolToColor(InputAvail, clWindow, clBtnFace);
  if not InputAvail then begin
    cbInputEnabled.Checked := false;
    edGroupCaptionChange(cbInputEnabled);
  end;
  rmCommutator1.LedOn.ActiveColor := boolToColor(InputAvail, clRed, clGray);
  rmCommutator1.SwitchOn.ActiveColor := boolToColor(InputAvail, clLime, clSilver);
  lblInputActive1.caption := boolToStr(InputAvail, sInputHandled, sInputNotHandled);
  lblInputActive2.caption := boolToStr(InputAvail, sInputHandledInactive, sInputNotHandledInactive);
  result := InputAvail;
end;

procedure TfmInputConfig.GetParameters(SelInputIdx: integer);
begin
  ReadDataInProgress := true;

  // refresh name group name
  {
  case GroupIndex of
    0..3 : lblGroupCaption.Caption := format(sGroupNameAnalog, [intToStr(GroupIndex + 1)]);
    4..7 : lblGroupCaption.Caption := format(sGroupNameDigital, [intToStr(GroupIndex + 1 - 4)]);
  end;
  }
  edGroupCaption.Text := Groups[GroupIndex].Caption;

  // activate and deactivate controls used for analog or digital inputs
  // and refresh input values or states
  //lblInputCaption.Caption := format(sInputName, [intToStr(InputIndex + 1)]);
  edInputCaption.Text := Inputs[SelInputIdx].Caption;
  cbInputEnabled.Checked := Inputs[SelInputIdx].InputEnabled;
  rbNominalStateOn.enabled := GroupIndex in [4..7];
  rbNominalStateOff.enabled := GroupIndex in [4..7];
  edMinLimit.enabled := GroupIndex in [0..3]; // only used on analog input
  edMinLimit.Color := boolToColor(edMinLimit.enabled, clWindow, clBtnFace);
  edMaxLimit.enabled := GroupIndex in [0..3]; // only used on analog input
  edMaxLimit.Color := boolToColor(edMaxLimit.enabled, clWindow, clBtnFace);
  cbStartAlarmEnabled.Checked := Inputs[SelInputIdx].StartAlarmEnabled;
  cbEndAlarmEnabled.Checked := Inputs[SelInputIdx].EndAlarmEnabled;
  edColor.SelectedColor := Inputs[SelInputIdx].LineColor;

  pnlValues.Visible := GroupIndex in [0..3];
  pnlStatus.Visible := GroupIndex in [4..7];

  case GroupIndex of

    // only for analog inputs
    0..3 : begin
      rbNominalStateOn.Checked := false;
      rbNominalStateOff.Checked := false;
      edActualValue.text := realToStr(3, Inputs[SelInputIdx].ActualValue);
      edCANFullScaleValue.Text :=  realToStr(3, Inputs[SelInputIdx].CANFullScaleValue);
      edMinLimit.Text := realToStr(3, Inputs[SelInputIdx].MinLimit);
      edMaxLimit.Text :=  realToStr(3, Inputs[SelInputIdx].MaxLimit);
      lblcbStartAlarmEnabled.Caption := 'Dclencher l''enregistrement si dpassement de la limite basse ou de la limite haute';
      lblcbEndAlarmEnabled.Caption   := 'Dclencher l''enregistrement lors du retour  une valeur nominale';
    end;

    // only for digital inputs
    4..7 : begin
      edActualStatus.text := BoolToStr(Inputs[SelInputIdx].ActualState, sON, sOFF);
      if Inputs[SelInputIdx].NominalStateIsOn then
        rbNominalStateOn.Checked := true
      else
        rbNominalStateOff.Checked := true;
      edAlarmeState.text := boolToStr(rbNominalStateON.checked, 'OFF', 'ON');
      edMinLimit.Text := '';
      edMaxLimit.Text := '';
      lblcbStartAlarmEnabled.Caption := 'Dclencher l''enregistrement lors du passage de l''tat nominal  l''tat d''alarme';
      lblcbEndAlarmEnabled.Caption   := 'Dclencher l''enregistrement lors du passage de l''tat d''alarme  l''tat nominal';
    end;
  end;
  //edDelayBeforeAlarm.value := Inputs[SelInputIdx].DelayBeforeAlarm;
  //edCountBeforeAlarm.value := Inputs[SelInputIdx].CountBeforeAlarm;

  // refresh input state
  //lblErrorDesc.caption := format('[%s] %s', [intToStr(Inputs[SelInputIdx].errorCode), fmMain.ErrorCodeToStr(Inputs[SelInputIdx].errorCode)]);

  ReadDataInProgress := false;

end;

procedure TfmInputConfig.edGroupCaptionChange(Sender: TObject);
begin
  SetParameters(SelectedInputIndex);
  if sender = cbInputEnabled then begin
    pnlInput.visible := cbInputEnabled.checked;
    edInputCaption.enabled := cbInputEnabled.Checked;
    edInputCaption.Color := boolToColor(cbInputEnabled.Checked, clWindow, clBtnFace);
    try
      //fmMain.Chart1.Series[SelectedInputIndex].active := cbInputEnabled.checked;
    except
    end;
  end;
end;

procedure TfmInputConfig.SetParameters(SelInputIdx: integer);
var
  sVal: string;
begin

  if ReadDataInProgress then exit;

  // only for group
  Groups[groupIndex].caption := edGroupCaption.text;

  // common to analog and digital inputs
  Inputs[SelInputIdx].InputEnabled := cbInputEnabled.Checked;
  Inputs[SelInputIdx].Caption := edInputCaption.text;
  //Inputs[SelInputIdx].DelayBeforeAlarm := edDelayBeforeAlarm.value;
  //Inputs[SelInputIdx].CountBeforeAlarm := edCountBeforeAlarm.value;
  Inputs[SelInputIdx].StartAlarmEnabled := cbStartAlarmEnabled.Checked;
  Inputs[SelInputIdx].EndAlarmEnabled := cbEndAlarmEnabled.Checked;
  // Inputs[SelInputIdx].ErrorCode := 0;
  Inputs[SelInputIdx].LineColor := edColor.SelectedColor;

  case SelInputIdx of

    // only for analog input
    000..063 : begin
      sVal := edCANFullScaleValue.text;
      if sVal = '' then sVal := '0.0';
      GetGoodDecimalSeparator(sVal);
      Inputs[SelInputIdx].CANFullScaleValue := strToFloat(sVal);

      sVal := edMinLimit.text;
      if sVal = '' then sVal := '0.0';
      GetGoodDecimalSeparator(sVal);
      Inputs[SelInputIdx].MinLimit := strToFloat(sVal);

      sVal := edMaxLimit.text;
      if sVal = '' then sVal := '0.0';
      GetGoodDecimalSeparator(sVal);
      Inputs[SelInputIdx].MaxLimit := strToFloat(sVal);
    end;

    // only for digital input
    064..127 : begin
      Inputs[SelInputIdx].NominalStateIsOn := rbNominalStateON.checked;
      edAlarmeState.text := boolToStr(rbNominalStateON.checked, 'OFF', 'ON');
    end;
  end;

  ActualConfigModified := true;
end;

procedure TfmInputConfig.mnuCloseClick(Sender: TObject);
begin
  close;
end;

procedure TfmInputConfig.mnuCopyClick(Sender: TObject);
begin
  ClipBrdInput := Inputs[selectedInputIndex];
end;

procedure TfmInputConfig.mnuPasteClick(Sender: TObject);
var
  sCaption: string;
begin
  // copy all TInput record fields, except input caption
  sCaption := Inputs[selectedInputIndex].Caption;
  Inputs[selectedInputIndex] := ClipBrdInput;
  Inputs[selectedInputIndex].Caption := sCaption;
  GetParameters(SelectedInputIndex);
end;

procedure TfmInputConfig.btnApplyClick(Sender: TObject);
begin
  Chart_RefreshSeries;
end;

procedure TfmInputConfig.btnRestoreClick(Sender: TObject);
begin
  fmMain.Data_RestoreFromRam;
  rmCommutator1Change(rmCommutator1);
  Chart_RefreshSeries;
end;

procedure TfmInputConfig.btnCancelClick(Sender: TObject);
begin
  fmMain.Data_RestoreFromRam;   // restore and close form
end;

procedure TfmInputConfig.btnReadActualValueClick(Sender: TObject);
begin
  // read actual analog input value
  if sender = btnReadActualValue then

  // read actual digital input value
  else if sender = btnReadActualState then
  
end;

end.
