unit frmOptions;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, ComCtrls, StdCtrls, ExtCtrls, lmdcombo, lmdextcS, lmdstdcA,
  ovcurl;

type
  TfmOptions = class(TForm)
    PageControl1: TPageControl;
    tsFormat: TTabSheet;
    rgLogDurationFormat: TRadioGroup;
    btnCancel: TBitBtn;
    btnOK: TBitBtn;
    btnApply: TSpeedButton;
    tsCapture: TTabSheet;
    GroupBox2: TGroupBox;
    cbPortsBaseAddressList: TComboBox;
    tsMisc: TTabSheet;
    GroupBox3: TGroupBox;
    cbMiscShowErrorMessages: TCheckBox;
    GroupBox5: TGroupBox;
    cbCaptureThreadPriority: TComboBox;
    tsReport: TTabSheet;
    rgReportSorting: TRadioGroup;
    GroupBox6: TGroupBox;
    cbLogPrintColors: TCheckBox;
    GroupBox4: TGroupBox;
    cbMiscMenuAsXPStyle: TCheckBox;
    cbLogShowGridLines: TCheckBox;
    tsBackup: TTabSheet;
    GroupBox7: TGroupBox;
    rbLogSaveAutoOnExit: TCheckBox;
    rbLogSaveAutoOnNewDay: TCheckBox;
    GroupBox8: TGroupBox;
    rbLogSaveMakeBackup: TCheckBox;
    GroupBox9: TGroupBox;
    edReportMainTitle: TEdit;
    GroupBox10: TGroupBox;
    edAppMainTitle: TEdit;
    Label1: TLabel;
    Label5: TLabel;
    edReportSubTitle: TEdit;
    tsInputs: TTabSheet;
    GroupBox11: TGroupBox;
    cbInputActive: TCheckBox;
    cbInputInvert: TCheckBox;
    cbInputList: TComboBox;
    GroupBox12: TGroupBox;
    cbCaptureSaveDuration: TCheckBox;
    cbCaptureSaveEdge: TCheckBox;
    cbLogUseColors: TCheckBox;
    edEventLabel: TEdit;
    Label4: TLabel;
    Label2: TLabel;
    ccLogEventTextColor: TLMDColorComboBox;
    ccLogEventBGColor: TLMDColorComboBox;
    Label3: TLabel;
    Label7: TLabel;
    lblEventPreview: TLabel;
    Label6: TLabel;
    edInputMinDuration: TLMDSpinEdit;
    Label8: TLabel;
    GroupBox1: TGroupBox;
    cbCaptureRunAtAppStartup: TCheckBox;
    cbMiscRunAppAtWindowsStartup: TCheckBox;
    rbLogSaveAutoOnNewEvent: TCheckBox;
    OvcURL2: TOvcURL;
    procedure btnOKClick(Sender: TObject);
    procedure btnApplyClick(Sender: TObject);
    procedure cbPortsBaseAddressListChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure cbInputListChange(Sender: TObject);
    procedure cbInputActiveClick(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure rbLogSaveAutoOnNewEventClick(Sender: TObject);
    procedure rbLogSaveAutoOnNewDayClick(Sender: TObject);
  private
    procedure SetPrefs;
    procedure RefreshGUI;
    procedure chekForActivateSaveAuto;
    procedure SetInputParams;
    { Dclarations prives }
  public
    { Dclarations publiques }
    procedure GetPrefs;
    procedure GetInputParams;
  end;


const
  ForcedPortBaseAddressIndex = 4;

var
  fmOptions: TfmOptions;

implementation

uses
  rmForms, rmMisc,
  uResStr, uUserPrefs, uLog, uCapture,
  frmMain;

{$R *.DFM}
var
  UserTemp: TUserPrefs;

procedure TfmOptions.FormCreate(Sender: TObject);
begin
  PageControl1.ActivePageIndex := 0;
  cbCaptureThreadPriority.ItemIndex := 2;
  OvcURL2.URL := appPath + 'a_lire.txt';

  // select input 1 params
  //cbInputList.ItemIndex := 0;
  //GetInputParams;

  // select LPT1 port (only port accepted at the moment)
  cbPortsBaseAddressList.ItemIndex := UserPrefs.PortBaseAddressIndex;
  cbPortsBaseAddressListChange(nil);
end;

procedure TfmOptions.GetPrefs;
begin

  with UserPrefs do
  begin

    // main
    edAppMainTitle.text := AppMainTitle;

    //log apparence
    rgLogDurationFormat.ItemIndex := LogDurationFormat;
    cbLogShowGridLines.Checked := LogShowGridLines;
    cbLogUseColors.Checked := LogUseColors;
    cbLogPrintColors.Checked := LogPrintColors;

    // log events parmaters
    UserTemp.LogEvent0Active := UserPrefs.LogEvent0Active;
    UserTemp.LogEvent1Active := UserPrefs.LogEvent1Active;
    UserTemp.LogEvent2Active := UserPrefs.LogEvent2Active;
    UserTemp.LogEvent3Active := UserPrefs.LogEvent3Active;
    UserTemp.LogEvent4Active := UserPrefs.LogEvent4Active;
    UserTemp.LogEvent5Active := UserPrefs.LogEvent5Active;
    UserTemp.LogEvent6Active := UserPrefs.LogEvent6Active;
    UserTemp.LogEvent7Active := UserPrefs.LogEvent7Active;
    UserTemp.LogEvent8Active := UserPrefs.LogEvent8Active;
    UserTemp.LogEvent9Active := UserPrefs.LogEvent9Active;
    UserTemp.LogEvent10Active := UserPrefs.LogEvent10Active;
    UserTemp.LogEvent11Active := UserPrefs.LogEvent11Active;
    UserTemp.LogEvent12Active := UserPrefs.LogEvent12Active;
    {
    UserTemp.LogEvent13Active := UserPrefs.LogEvent13Active;
    UserTemp.LogEvent14Active := UserPrefs.LogEvent14Active;
    UserTemp.LogEvent15Active := UserPrefs.LogEvent15Active;
    UserTemp.LogEvent16Active := UserPrefs.LogEvent16Active;
    }
    UserTemp.LogEvent0Invert := UserPrefs.LogEvent0Invert;
    UserTemp.LogEvent1Invert := UserPrefs.LogEvent1Invert;
    UserTemp.LogEvent2Invert := UserPrefs.LogEvent2Invert;
    UserTemp.LogEvent3Invert := UserPrefs.LogEvent3Invert;
    UserTemp.LogEvent4Invert := UserPrefs.LogEvent4Invert;
    UserTemp.LogEvent5Invert := UserPrefs.LogEvent5Invert;
    UserTemp.LogEvent6Invert := UserPrefs.LogEvent6Invert;
    UserTemp.LogEvent7Invert := UserPrefs.LogEvent7Invert;
    UserTemp.LogEvent8Invert := UserPrefs.LogEvent8Invert;
    UserTemp.LogEvent9Invert := UserPrefs.LogEvent9Invert;
    UserTemp.LogEvent10Invert := UserPrefs.LogEvent10Invert;
    UserTemp.LogEvent11Invert := UserPrefs.LogEvent11Invert;
    UserTemp.LogEvent12Invert := UserPrefs.LogEvent12Invert;
    {
    UserTemp.LogEvent13Invert := UserPrefs.LogEvent13Invert;
    UserTemp.LogEvent14Invert := UserPrefs.LogEvent14Invert;
    UserTemp.LogEvent15Invert := UserPrefs.LogEvent15Invert;
    UserTemp.LogEvent16Invert := UserPrefs.LogEvent16Invert;
    }
    UserTemp.LogEvent0MinDuration := UserPrefs.LogEvent0MinDuration;
    UserTemp.LogEvent1MinDuration := UserPrefs.LogEvent1MinDuration;
    UserTemp.LogEvent2MinDuration := UserPrefs.LogEvent2MinDuration;
    UserTemp.LogEvent3MinDuration := UserPrefs.LogEvent3MinDuration;
    UserTemp.LogEvent4MinDuration := UserPrefs.LogEvent4MinDuration;
    UserTemp.LogEvent5MinDuration := UserPrefs.LogEvent5MinDuration;
    UserTemp.LogEvent6MinDuration := UserPrefs.LogEvent6MinDuration;
    UserTemp.LogEvent7MinDuration := UserPrefs.LogEvent7MinDuration;
    UserTemp.LogEvent8MinDuration := UserPrefs.LogEvent8MinDuration;
    UserTemp.LogEvent9MinDuration := UserPrefs.LogEvent9MinDuration;
    UserTemp.LogEvent10MinDuration := UserPrefs.LogEvent10MinDuration;
    UserTemp.LogEvent11MinDuration := UserPrefs.LogEvent11MinDuration;
    UserTemp.LogEvent12MinDuration := UserPrefs.LogEvent12MinDuration;
    {
    UserTemp.LogEvent13MinDuration := UserPrefs.LogEvent13MinDuration;
    UserTemp.LogEvent14MinDuration := UserPrefs.LogEvent14MinDuration;
    UserTemp.LogEvent15MinDuration := UserPrefs.LogEvent15MinDuration;
    UserTemp.LogEvent16MinDuration := UserPrefs.LogEvent16MinDuration;
    }
    UserTemp.LogEvent0Label := UserPrefs.LogEvent0Label;
    UserTemp.LogEvent1Label := UserPrefs.LogEvent1Label;
    UserTemp.LogEvent2Label := UserPrefs.LogEvent2Label;
    UserTemp.LogEvent3Label := UserPrefs.LogEvent3Label;
    UserTemp.LogEvent4Label := UserPrefs.LogEvent4Label;
    UserTemp.LogEvent5Label := UserPrefs.LogEvent5Label;
    UserTemp.LogEvent6Label := UserPrefs.LogEvent6Label;
    UserTemp.LogEvent7Label := UserPrefs.LogEvent7Label;
    UserTemp.LogEvent8Label := UserPrefs.LogEvent8Label;
    UserTemp.LogEvent9Label := UserPrefs.LogEvent9Label;
    UserTemp.LogEvent10Label := UserPrefs.LogEvent10Label;
    UserTemp.LogEvent11Label := UserPrefs.LogEvent11Label;
    UserTemp.LogEvent12Label := UserPrefs.LogEvent12Label;
    {
    UserTemp.LogEvent13Label := UserPrefs.LogEvent13Label;
    UserTemp.LogEvent14Label := UserPrefs.LogEvent14Label;
    UserTemp.LogEvent15Label := UserPrefs.LogEvent15Label;
    UserTemp.LogEvent16Label := UserPrefs.LogEvent16Label;
    }
    UserTemp.LogEvent0TextColor := UserPrefs.LogEvent0TextColor;
    UserTemp.LogEvent1TextColor := UserPrefs.LogEvent1TextColor;
    UserTemp.LogEvent2TextColor := UserPrefs.LogEvent2TextColor;
    UserTemp.LogEvent3TextColor := UserPrefs.LogEvent3TextColor;
    UserTemp.LogEvent4TextColor := UserPrefs.LogEvent4TextColor;
    UserTemp.LogEvent5TextColor := UserPrefs.LogEvent5TextColor;
    UserTemp.LogEvent6TextColor := UserPrefs.LogEvent6TextColor;
    UserTemp.LogEvent7TextColor := UserPrefs.LogEvent7TextColor;
    UserTemp.LogEvent8TextColor := UserPrefs.LogEvent8TextColor;
    UserTemp.LogEvent9TextColor := UserPrefs.LogEvent9TextColor;
    UserTemp.LogEvent10TextColor := UserPrefs.LogEvent10TextColor;
    UserTemp.LogEvent11TextColor := UserPrefs.LogEvent11TextColor;
    UserTemp.LogEvent12TextColor := UserPrefs.LogEvent12TextColor;
    {
    UserTemp.LogEvent13TextColor := UserPrefs.LogEvent13TextColor;
    UserTemp.LogEvent14TextColor := UserPrefs.LogEvent14TextColor;
    UserTemp.LogEvent15TextColor := UserPrefs.LogEvent15TextColor;
    UserTemp.LogEvent16TextColor := UserPrefs.LogEvent16TextColor;
    }
    UserTemp.LogEvent0BGColor := UserPrefs.LogEvent0BGColor;
    UserTemp.LogEvent1BGColor := UserPrefs.LogEvent1BGColor;
    UserTemp.LogEvent2BGColor := UserPrefs.LogEvent2BGColor;
    UserTemp.LogEvent3BGColor := UserPrefs.LogEvent3BGColor;
    UserTemp.LogEvent4BGColor := UserPrefs.LogEvent4BGColor;
    UserTemp.LogEvent5BGColor := UserPrefs.LogEvent5BGColor;
    UserTemp.LogEvent6BGColor := UserPrefs.LogEvent6BGColor;
    UserTemp.LogEvent7BGColor := UserPrefs.LogEvent7BGColor;
    UserTemp.LogEvent8BGColor := UserPrefs.LogEvent8BGColor;
    UserTemp.LogEvent9BGColor := UserPrefs.LogEvent9BGColor;
    UserTemp.LogEvent10BGColor := UserPrefs.LogEvent10BGColor;
    UserTemp.LogEvent11BGColor := UserPrefs.LogEvent11BGColor;
    UserTemp.LogEvent12BGColor := UserPrefs.LogEvent12BGColor;
    {
    UserTemp.LogEvent13BGColor := UserPrefs.LogEvent13BGColor;
    UserTemp.LogEvent14BGColor := UserPrefs.LogEvent14BGColor;
    UserTemp.LogEvent15BGColor := UserPrefs.LogEvent15BGColor;
    UserTemp.LogEvent16BGColor := UserPrefs.LogEvent16BGColor;
    }

    // log save
    rbLogSaveAutoOnExit.Checked := LogSaveAutoOnExit;
    rbLogSaveAutoOnNewDay.Checked := LogSaveAutoOnNewDay;
    rbLogSaveAutoOnNewEvent.Checked := LogSaveAutoOnNewEvent;
    rbLogSaveMakeBackup.Checked := LogSaveMakeBackup;

    // capture
    cbCaptureThreadPriority.ItemIndex := CaptureThreadPriority;
    cbCaptureRunAtAppStartup.Checked := CaptureRunAtAppStartup;
    cbCaptureSaveEdge.Checked := CaptureSaveEdge;
    cbCaptureSaveDuration.Checked := CaptureSaveDuration;
    cbPortsBaseAddressList.ItemIndex := PortBaseAddressIndex;

    // report
    rgReportSorting.ItemIndex := ReportSorting;
    edReportMainTitle.Text := ReportMainTitle;
    edReportSubTitle.Text := ReportSubTitle;

    // misc
    cbMiscRunAppAtWindowsStartup.Checked := MiscRunAppAtWindowsStartup;
    cbMiscMenuAsXPStyle.Checked := MiscMenuAsXPStyle;
    cbMiscShowErrorMessages.Checked := MiscShowErrorMessages;

  end;

  // refresh options GUI controls
  RefreshGUI;
end;

procedure TfmOptions.RefreshGUI;
begin
  // log events parameters
  //cbInputActive.Enabled := cbLogUseColors.Checked;
  cbInputInvert.Enabled := cbInputActive.Checked;
  edInputMinDuration.Enabled := cbInputActive.Checked;
  //cbInputList.Enabled := cbLogUseColors.Checked;
  edEventLabel.Enabled := cbInputActive.Checked;
  lblEventPreview.Caption := edEventLabel.text;
  lblEventPreview.visible := cbInputActive.Checked;
  ccLogEventTextColor.Enabled := cbLogUseColors.Checked and cbInputActive.Checked;
  ccLogEventBGColor.Enabled := cbLogUseColors.Checked and cbInputActive.Checked;

  if cbLogUseColors.Checked then
  begin
    lblEventPreview.Font.Color := ccLogEventTextColor.SelectedColor;
    lblEventPreview.Color := ccLogEventBGColor.SelectedColor;
  end
  else
  begin
    lblEventPreview.Font.Color := clWindowText;
    lblEventPreview.Color := clWindow;
  end;
end;

procedure TfmOptions.SetPrefs;
begin

  //showmessage(UserTemp.LogEvent1Label);

  with UserPrefs do
  begin

    // main
    AppMainTitle := edAppMainTitle.text;

    // log apparence
    LogDurationFormat := rgLogDurationFormat.ItemIndex;
    LogShowGridLines := cbLogShowGridLines.Checked;
    LogUseColors := cbLogUseColors.Checked;
    LogPrintColors := cbLogPrintColors.Checked;

    // log events parmaters
    UserPrefs.LogEvent0Active := UserTemp.LogEvent0Active;
    UserPrefs.LogEvent1Active := UserTemp.LogEvent1Active;
    UserPrefs.LogEvent2Active := UserTemp.LogEvent2Active;
    UserPrefs.LogEvent3Active := UserTemp.LogEvent3Active;
    UserPrefs.LogEvent4Active := UserTemp.LogEvent4Active;
    UserPrefs.LogEvent5Active := UserTemp.LogEvent5Active;
    UserPrefs.LogEvent6Active := UserTemp.LogEvent6Active;
    UserPrefs.LogEvent7Active := UserTemp.LogEvent7Active;
    UserPrefs.LogEvent8Active := UserTemp.LogEvent8Active;
    UserPrefs.LogEvent9Active := UserTemp.LogEvent9Active;
    UserPrefs.LogEvent10Active := UserTemp.LogEvent10Active;
    UserPrefs.LogEvent11Active := UserTemp.LogEvent11Active;
    UserPrefs.LogEvent12Active := UserTemp.LogEvent12Active;
    {
    UserPrefs.LogEvent13Active := UserTemp.LogEvent13Active;
    UserPrefs.LogEvent14Active := UserTemp.LogEvent14Active;
    UserPrefs.LogEvent15Active := UserTemp.LogEvent15Active;
    UserPrefs.LogEvent16Active := UserTemp.LogEvent16Active;
    }
    UserPrefs.LogEvent0Invert := UserTemp.LogEvent0Invert;
    UserPrefs.LogEvent1Invert := UserTemp.LogEvent1Invert;
    UserPrefs.LogEvent2Invert := UserTemp.LogEvent2Invert;
    UserPrefs.LogEvent3Invert := UserTemp.LogEvent3Invert;
    UserPrefs.LogEvent4Invert := UserTemp.LogEvent4Invert;
    UserPrefs.LogEvent5Invert := UserTemp.LogEvent5Invert;
    UserPrefs.LogEvent6Invert := UserTemp.LogEvent6Invert;
    UserPrefs.LogEvent7Invert := UserTemp.LogEvent7Invert;
    UserPrefs.LogEvent8Invert := UserTemp.LogEvent8Invert;
    UserPrefs.LogEvent9Invert := UserTemp.LogEvent9Invert;
    UserPrefs.LogEvent10Invert := UserTemp.LogEvent10Invert;
    UserPrefs.LogEvent11Invert := UserTemp.LogEvent11Invert;
    UserPrefs.LogEvent12Invert := UserTemp.LogEvent12Invert;
    {
    UserPrefs.LogEvent13Invert := UserTemp.LogEvent13Invert;
    UserPrefs.LogEvent14Invert := UserTemp.LogEvent14Invert;
    UserPrefs.LogEvent15Invert := UserTemp.LogEvent15Invert;
    UserPrefs.LogEvent16Invert := UserTemp.LogEvent16Invert;
    }
    UserPrefs.LogEvent0MinDuration := UserTemp.LogEvent0MinDuration;
    UserPrefs.LogEvent1MinDuration := UserTemp.LogEvent1MinDuration;
    UserPrefs.LogEvent2MinDuration := UserTemp.LogEvent2MinDuration;
    UserPrefs.LogEvent3MinDuration := UserTemp.LogEvent3MinDuration;
    UserPrefs.LogEvent4MinDuration := UserTemp.LogEvent4MinDuration;
    UserPrefs.LogEvent5MinDuration := UserTemp.LogEvent5MinDuration;
    UserPrefs.LogEvent6MinDuration := UserTemp.LogEvent6MinDuration;
    UserPrefs.LogEvent7MinDuration := UserTemp.LogEvent7MinDuration;
    UserPrefs.LogEvent8MinDuration := UserTemp.LogEvent8MinDuration;
    UserPrefs.LogEvent9MinDuration := UserTemp.LogEvent9MinDuration;
    UserPrefs.LogEvent10MinDuration := UserTemp.LogEvent10MinDuration;
    UserPrefs.LogEvent11MinDuration := UserTemp.LogEvent11MinDuration;
    UserPrefs.LogEvent12MinDuration := UserTemp.LogEvent12MinDuration;
    {
    UserPrefs.LogEvent13MinDuration := UserTemp.LogEvent13MinDuration;
    UserPrefs.LogEvent14MinDuration := UserTemp.LogEvent14MinDuration;
    UserPrefs.LogEvent15MinDuration := UserTemp.LogEvent15MinDuration;
    UserPrefs.LogEvent16MinDuration := UserTemp.LogEvent16MinDuration;
    }
    UserPrefs.LogEvent0Label := UserTemp.LogEvent0Label;
    UserPrefs.LogEvent1Label := UserTemp.LogEvent1Label;
    UserPrefs.LogEvent2Label := UserTemp.LogEvent2Label;
    UserPrefs.LogEvent3Label := UserTemp.LogEvent3Label;
    UserPrefs.LogEvent4Label := UserTemp.LogEvent4Label;
    UserPrefs.LogEvent5Label := UserTemp.LogEvent5Label;
    UserPrefs.LogEvent6Label := UserTemp.LogEvent6Label;
    UserPrefs.LogEvent7Label := UserTemp.LogEvent7Label;
    UserPrefs.LogEvent8Label := UserTemp.LogEvent8Label;
    UserPrefs.LogEvent9Label := UserTemp.LogEvent9Label;
    UserPrefs.LogEvent10Label := UserTemp.LogEvent10Label;
    UserPrefs.LogEvent11Label := UserTemp.LogEvent11Label;
    UserPrefs.LogEvent12Label := UserTemp.LogEvent12Label;
    {
    UserPrefs.LogEvent13Label := UserTemp.LogEvent13Label;
    UserPrefs.LogEvent14Label := UserTemp.LogEvent14Label;
    UserPrefs.LogEvent15Label := UserTemp.LogEvent15Label;
    UserPrefs.LogEvent16Label := UserTemp.LogEvent16Label;
    }
    UserPrefs.LogEvent0TextColor := UserTemp.LogEvent0TextColor;
    UserPrefs.LogEvent1TextColor := UserTemp.LogEvent1TextColor;
    UserPrefs.LogEvent2TextColor := UserTemp.LogEvent2TextColor;
    UserPrefs.LogEvent3TextColor := UserTemp.LogEvent3TextColor;
    UserPrefs.LogEvent4TextColor := UserTemp.LogEvent4TextColor;
    UserPrefs.LogEvent5TextColor := UserTemp.LogEvent5TextColor;
    UserPrefs.LogEvent6TextColor := UserTemp.LogEvent6TextColor;
    UserPrefs.LogEvent7TextColor := UserTemp.LogEvent7TextColor;
    UserPrefs.LogEvent8TextColor := UserTemp.LogEvent8TextColor;
    UserPrefs.LogEvent9TextColor := UserTemp.LogEvent9TextColor;
    UserPrefs.LogEvent10TextColor := UserTemp.LogEvent10TextColor;
    UserPrefs.LogEvent11TextColor := UserTemp.LogEvent11TextColor;
    UserPrefs.LogEvent12TextColor := UserTemp.LogEvent12TextColor;
    {
    UserPrefs.LogEvent13TextColor := UserTemp.LogEvent13TextColor;
    UserPrefs.LogEvent14TextColor := UserTemp.LogEvent14TextColor;
    UserPrefs.LogEvent15TextColor := UserTemp.LogEvent15TextColor;
    UserPrefs.LogEvent16TextColor := UserTemp.LogEvent16TextColor;
    }
    UserPrefs.LogEvent0BGColor := UserTemp.LogEvent0BGColor;
    UserPrefs.LogEvent1BGColor := UserTemp.LogEvent1BGColor;
    UserPrefs.LogEvent2BGColor := UserTemp.LogEvent2BGColor;
    UserPrefs.LogEvent3BGColor := UserTemp.LogEvent3BGColor;
    UserPrefs.LogEvent4BGColor := UserTemp.LogEvent4BGColor;
    UserPrefs.LogEvent5BGColor := UserTemp.LogEvent5BGColor;
    UserPrefs.LogEvent6BGColor := UserTemp.LogEvent6BGColor;
    UserPrefs.LogEvent7BGColor := UserTemp.LogEvent7BGColor;
    UserPrefs.LogEvent8BGColor := UserTemp.LogEvent8BGColor;
    UserPrefs.LogEvent9BGColor := UserTemp.LogEvent9BGColor;
    UserPrefs.LogEvent10BGColor := UserTemp.LogEvent10BGColor;
    UserPrefs.LogEvent11BGColor := UserTemp.LogEvent11BGColor;
    UserPrefs.LogEvent12BGColor := UserTemp.LogEvent12BGColor;
    {
    UserPrefs.LogEvent13BGColor := UserTemp.LogEvent13BGColor;
    UserPrefs.LogEvent14BGColor := UserTemp.LogEvent14BGColor;
    UserPrefs.LogEvent15BGColor := UserTemp.LogEvent15BGColor;
    UserPrefs.LogEvent16BGColor := UserTemp.LogEvent16BGColor;
    }

    // log save
    LogSaveAutoOnExit := rbLogSaveAutoOnExit.Checked;
    LogSaveAutoOnNewDay := rbLogSaveAutoOnNewDay.Checked;
    LogSaveAutoOnNewEvent := rbLogSaveAutoOnNewEvent.Checked;
    LogSaveMakeBackup := rbLogSaveMakeBackup.Checked;

    // capture
    CaptureThreadPriority := cbCaptureThreadPriority.ItemIndex;
    CaptureRunAtAppStartup := cbCaptureRunAtAppStartup.Checked;
    CaptureSaveEdge := cbCaptureSaveEdge.Checked;
    CaptureSaveDuration := cbCaptureSaveDuration.Checked;
    PortBaseAddressIndex := cbPortsBaseAddressList.ItemIndex;

    // report
    ReportSorting := rgReportSorting.ItemIndex;
    ReportMainTitle := edReportMainTitle.Text;
    ReportSubTitle := edReportSubTitle.Text;

    // misc
    MiscRunAppAtWindowsStartup := cbMiscRunAppAtWindowsStartup.Checked;
    MiscMenuAsXPStyle := cbMiscMenuAsXPStyle.Checked;
    MiscShowErrorMessages := cbMiscShowErrorMessages.Checked;

  end;

  // refresh options in app
  UserPrefs_Apply;

  // refresh main form status bar
  fmMain.App_RefreshGUIStatusBar;
end;


procedure TfmOptions.btnOKClick(Sender: TObject);
begin
  SetPrefs;
end;

procedure TfmOptions.btnApplyClick(Sender: TObject);
begin
  SetPrefs;
end;

procedure TfmOptions.cbPortsBaseAddressListChange(Sender: TObject);
begin
  // actually, only support of LPT ports
  if not (cbPortsBaseAddressList.ItemIndex in [LPTIndexMin..LPTIndexMax]) then
  begin
    messageDlg('Actuellement, seuls les ports parallles (LPT1, LPT2) sont supports.', mtInformation, [mbOK], 0);
    cbPortsBaseAddressList.ItemIndex := ForcedPortBaseAddressIndex;
  end;
  RefreshGUI;
end;

procedure TfmOptions.chekForActivateSaveAuto;
begin


end;

procedure TfmOptions.cbInputListChange(Sender: TObject);
begin
  GetInputParams;
end;

procedure TfmOptions.GetInputParams;
var
  idx: integer;
  bActive,
  bInvert: boolean;
  iMinDuration: integer;
  sLabel: string;
  clTextColor, clBGColor: TColor;
begin
  // deactivate event handler to avoid infinite loop
  cbInputList.OnChange := nil;
  cbInputActive.OnClick := nil;
  cbInputInvert.OnClick := nil;
  edInputMinDuration.OnChange := nil;
  edEventLabel.OnChange := nil;
  ccLogEventTextColor.OnChange := nil;
  ccLogEventBGColor.OnChange := nil;

  // get params
  idx := cbInputList.ItemIndex;
  Log_GetEventParams(
     UserTemp,
     idx,
     bActive,
     bInvert,
     iMinDuration,
     sLabel,
     clTextColor,
     clBGColor);

  // refresh values
  cbInputActive.Checked := bActive;
  cbInputInvert.Checked := bInvert;
  edInputMinDuration.Value := iMinDuration;
  edEventLabel.Text := sLabel;
  ccLogEventTextColor.SelectedColor := clTextColor;
  ccLogEventBGColor.SelectedColor := clBGColor;

  // refresh GUI controls
  RefreshGUI;

  // deactivate event handler to avoid infinite loop
  cbInputList.OnChange := cbInputListChange;
  cbInputActive.OnClick := cbInputActiveClick;
  cbInputInvert.OnClick := cbInputActiveClick;
  edInputMinDuration.OnChange := cbInputActiveClick;
  edEventLabel.OnChange := cbInputActiveClick;
  ccLogEventTextColor.OnChange := cbInputActiveClick;
  ccLogEventBGColor.OnChange := cbInputActiveClick;
end;


procedure TfmOptions.cbInputActiveClick(Sender: TObject);
begin
  SetInputParams;
  RefreshGUI;
end;

procedure TfmOptions.SetInputParams;
var
  idx: integer;
  bActive,
  bInvert: boolean;
  sLabel: string;
  clTextColor, clBGColor: TColor;
begin
  // get params
  idx := cbInputList.ItemIndex;
  Log_SetEventParams(
     UserTemp,
     idx,
     cbInputActive.checked,
     cbInputInvert.checked,
     edInputMinDuration.value,
     edEventLabel.Text,
     ccLogEventTextColor.SelectedColor,
     ccLogEventBGColor.SelectedColor);
  //showmessage(UserTemp.LogEvent1Label);
end;

procedure TfmOptions.PageControl1Change(Sender: TObject);
begin
  if PageControl1.ActivePage = tsInputs then
    cbInputList.SetFocus;
end;

procedure TfmOptions.rbLogSaveAutoOnNewDayClick(Sender: TObject);
begin
  if (not rbLogSaveAutoOnNewDay.checked) and
  (rbLogSaveAutoOnNewEvent.Checked) then
    rbLogSaveAutoOnNewEvent.Checked := false;
end;

procedure TfmOptions.rbLogSaveAutoOnNewEventClick(Sender: TObject);
begin
  if rbLogSaveAutoOnNewEvent.checked and
  (not rbLogSaveAutoOnNewDay.Checked) then
    rbLogSaveAutoOnNewDay.Checked := true;
end;

end.
