unit frmProgress;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, ExtCtrls, BUSpecialProgress;

type
  TfmProgress = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    ProgressBar1: TProgressBar;
    Shape1: TShape;
    procedure FormCreate(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    procedure PF_Show;
    procedure PF_Hide;
    procedure PF_Init(iMin, iMax: integer; lbl1, lbl2: string);
    procedure PF_RefreshGauge(const i: integer);
  end;

var
  fmProgress: TfmProgress;

implementation

uses
  rmForms;

{$R *.DFM}

procedure TfmProgress.FormCreate(Sender: TObject);
begin
  label1.Caption := '';
  label2.Caption := '';
end;

procedure TfmProgress.PF_Show;
begin
  rmForms.ShowForm(fmProgress, false);
end;

procedure TfmProgress.PF_Hide;
begin
  rmForms.CloseForm(fmProgress);
end;

procedure TfmProgress.PF_Init(iMin, iMax: integer; lbl1, lbl2: string);
begin
  ProgressBar1.Min := iMin;
  ProgressBar1.Max := iMax;
  if lbl1 <> '' then
    label1.Caption := lbl1;
  if lbl2 <> '' then
    label2.Caption := lbl2;
  application.ProcessMessages;
end;

procedure TfmProgress.PF_RefreshGauge(const i: integer);
begin
  ProgressBar1.Position := i;
end;



end.
