unit uConf;

interface

uses
  Classes, SysUtils, IniFiles, Graphics, Dialogs,
  uCapture;

type

  TCaptureConf = record

    // log
    Input0Active: boolean;
    Input1Active: boolean;
    Input2Active: boolean;
    Input3Active: boolean;
    Input4Active: boolean;
    Input5Active: boolean;
    Input6Active: boolean;
    Input7Active: boolean;
    Input8Active: boolean;
    Input9Active: boolean;
    Input10Active: boolean;
    Input11Active: boolean;
    Input12Active: boolean;
    {
    Input13Active: boolean;
    Input14Active: boolean;
    Input15Active: boolean;
    Input16Active: boolean;
    }
    Input0Invert: boolean;
    Input1Invert: boolean;
    Input2Invert: boolean;
    Input3Invert: boolean;
    Input4Invert: boolean;
    Input5Invert: boolean;
    Input6Invert: boolean;
    Input7Invert: boolean;
    Input8Invert: boolean;
    Input9Invert: boolean;
    Input10Invert: boolean;
    Input11Invert: boolean;
    Input12Invert: boolean;
    {
    Input13Invert: boolean;
    Input14Invert: boolean;
    Input15Invert: boolean;
    Input16Invert: boolean;
    }
    Input0MinDuration: integer;
    Input1MinDuration: integer;
    Input2MinDuration: integer;
    Input3MinDuration: integer;
    Input4MinDuration: integer;
    Input5MinDuration: integer;
    Input6MinDuration: integer;
    Input7MinDuration: integer;
    Input8MinDuration: integer;
    Input9MinDuration: integer;
    Input10MinDuration: integer;
    Input11MinDuration: integer;
    Input12MinDuration: integer;
    {
    Input13MinDuration: integer;
    Input14MinDuration: integer;
    Input15MinDuration: integer;
    Input16MinDuration: integer;
    }
    Input0Label: string;
    Input1Label: string;
    Input2Label: string;
    Input3Label: string;
    Input4Label: string;
    Input5Label: string;
    Input6Label: string;
    Input7Label: string;
    Input8Label: string;
    Input9Label: string;
    Input10Label: string;
    Input11Label: string;
    Input12Label: string;
    {
    Input13Label: string;
    Input14Label: string;
    Input15Label: string;
    Input16Label: string;
    }
    Input0TextColor: integer;
    Input1TextColor: integer;
    Input2TextColor: integer;
    Input3TextColor: integer;
    Input4TextColor: integer;
    Input5TextColor: integer;
    Input6TextColor: integer;
    Input7TextColor: integer;
    Input8TextColor: integer;
    Input9TextColor: integer;
    Input10TextColor: integer;
    Input11TextColor: integer;
    Input12TextColor: integer;
    {
    Input13TextColor: integer;
    Input14TextColor: integer;
    Input15TextColor: integer;
    Input16TextColor: integer;
    }
    Input0BGColor: integer;
    Input1BGColor: integer;
    Input2BGColor: integer;
    Input3BGColor: integer;
    Input4BGColor: integer;
    Input5BGColor: integer;
    Input6BGColor: integer;
    Input7BGColor: integer;
    Input8BGColor: integer;
    Input9BGColor: integer;
    Input10BGColor: integer;
    Input11BGColor: integer;
    Input12BGColor: integer;
    {
    Input13BGColor: integer;
    Input14BGColor: integer;
    Input15BGColor: integer;
    Input16BGColor: integer;
    }

    // capture
    CaptureThreadPriority: integer;
    CaptureSaveEdge: boolean;
    CaptureSaveDuration: boolean;
    PortBaseAddressIndex: integer;

    // report
    ReportSorting: integer;
    ReportMainTitle: string;
    ReportSubTitle: string;

    // misc
    AppMainTitle: string;
    GridColumnCaption0: string;
    GridColumnCaption1: string;
    GridColumnCaption2: string;
    GridColumnCaption3: string;

  end;

procedure Conf_LoadFromFile(const sFile: string);
procedure Conf_Apply;
procedure Conf_SaveToFile(const sFile: string);
procedure Conf_SetOpenedConfFile(sFile: string);
procedure Conf_SetOpenedConfModified(bState: boolean);

var
  CaptureConf: TCaptureConf;

Const
  sUserPrefsSection = 'UserPrefs';

implementation

uses
  rmMisc,
  uResStr, uLog, uUserPrefs,
  frmMain;

procedure Conf_LoadFromFile(const sFile: string);
var
  Ini: TInifile;
  i: integer;
  val: integer;
begin

  UserPrefs_Load(sFile);
  Conf_SetOpenedConfFile(sFile);
  Conf_SetOpenedConfModified(False);

  exit;


  with CaptureConf do
  begin
    ini := TInifile.Create(sFile);
    try

      // main
      AppMainTitle := ini.ReadString(sUserPrefsSection, 'AppMainTitle', 'Acquisition de donnes');

      // grid columns caption
      GridColumnCaption0 := ini.ReadString(sUserPrefsSection, 'GridColumnCaption0', 'Evenement');
      GridColumnCaption1 := ini.ReadString(sUserPrefsSection, 'GridColumnCaption1', 'TS');
      GridColumnCaption2 := ini.ReadString(sUserPrefsSection, 'GridColumnCaption2', 'Date / Heure');
      GridColumnCaption3 := ini.ReadString(sUserPrefsSection, 'GridColumnCaption3', 'Dure');

      // listView columns size
      for i := 0 to pred(fmMain.lvEventsList.Columns.Count) do
      begin
        val := ini.ReadInteger(
                 'GUIControlsSizeAndPos',
                 format('EventsList_Column%d_Width', [i]),
                 -1);
        if val > -1 then
          fmMain.lvEventsList.Columns[i].width := val;
      end;

      // log events colors
      Input0Active := ini.ReadBool(sUserPrefsSection, 'Input0Active', true);
      Input1Active := ini.ReadBool(sUserPrefsSection, 'Input1Active', true);
      Input2Active := ini.ReadBool(sUserPrefsSection, 'Input2Active', true);
      Input3Active := ini.ReadBool(sUserPrefsSection, 'Input3Active', true);
      Input4Active := ini.ReadBool(sUserPrefsSection, 'Input4Active', true);
      Input5Active := ini.ReadBool(sUserPrefsSection, 'Input5Active', true);
      Input6Active := ini.ReadBool(sUserPrefsSection, 'Input6Active', true);
      Input7Active := ini.ReadBool(sUserPrefsSection, 'Input7Active', true);
      Input8Active := ini.ReadBool(sUserPrefsSection, 'Input8Active', true);
      Input9Active := ini.ReadBool(sUserPrefsSection, 'Input9Active', true);
      Input10Active := ini.ReadBool(sUserPrefsSection, 'Input10Active', true);
      Input11Active := ini.ReadBool(sUserPrefsSection, 'Input11Active', true);
      Input12Active := ini.ReadBool(sUserPrefsSection, 'Input12Active', true);
      {
      Input13Active := ini.ReadBool(sUserPrefsSection, 'Input13Active', true);
      Input14Active := ini.ReadBool(sUserPrefsSection, 'Input14Active', true);
      Input15Active := ini.ReadBool(sUserPrefsSection, 'Input15Active', true);
      Input16Active := ini.ReadBool(sUserPrefsSection, 'Input16Active', true);
      }
      Input0Invert := ini.ReadBool(sUserPrefsSection, 'Input0Invert', false);
      Input1Invert := ini.ReadBool(sUserPrefsSection, 'Input1Invert', false);
      Input2Invert := ini.ReadBool(sUserPrefsSection, 'Input2Invert', false);
      Input3Invert := ini.ReadBool(sUserPrefsSection, 'Input3Invert', false);
      Input4Invert := ini.ReadBool(sUserPrefsSection, 'Input4Invert', false);
      Input5Invert := ini.ReadBool(sUserPrefsSection, 'Input5Invert', false);
      Input6Invert := ini.ReadBool(sUserPrefsSection, 'Input6Invert', false);
      Input7Invert := ini.ReadBool(sUserPrefsSection, 'Input7Invert', false);
      Input8Invert := ini.ReadBool(sUserPrefsSection, 'Input8Invert', false);
      Input9Invert := ini.ReadBool(sUserPrefsSection, 'Input9Invert', false);
      Input10Invert := ini.ReadBool(sUserPrefsSection, 'Input10Invert', false);
      Input11Invert := ini.ReadBool(sUserPrefsSection, 'Input11Invert', false);
      Input12Invert := ini.ReadBool(sUserPrefsSection, 'Input12Invert', false);
      {
      Input13Invert := ini.ReadBool(sUserPrefsSection, 'Input13Invert', false);
      Input14Invert := ini.ReadBool(sUserPrefsSection, 'Input14Invert', false);
      Input15Invert := ini.ReadBool(sUserPrefsSection, 'Input15Invert', false);
      Input16Invert := ini.ReadBool(sUserPrefsSection, 'Input16Invert', false);
      }
      Input0MinDuration := ini.ReadInteger(sUserPrefsSection, 'Input0MinDuration', 2);
      Input1MinDuration := ini.ReadInteger(sUserPrefsSection, 'Input1MinDuration', 2);
      Input2MinDuration := ini.ReadInteger(sUserPrefsSection, 'Input2MinDuration', 2);
      Input3MinDuration := ini.ReadInteger(sUserPrefsSection, 'Input3MinDuration', 2);
      Input4MinDuration := ini.ReadInteger(sUserPrefsSection, 'Input4MinDuration', 2);
      Input5MinDuration := ini.ReadInteger(sUserPrefsSection, 'Input5MinDuration', 2);
      Input6MinDuration := ini.ReadInteger(sUserPrefsSection, 'Input6MinDuration', 2);
      Input7MinDuration := ini.ReadInteger(sUserPrefsSection, 'Input7MinDuration', 2);
      Input8MinDuration := ini.ReadInteger(sUserPrefsSection, 'Input8MinDuration', 2);
      Input9MinDuration := ini.ReadInteger(sUserPrefsSection, 'Input9MinDuration', 2);
      Input10MinDuration := ini.ReadInteger(sUserPrefsSection, 'Input10MinDuration', 2);
      Input11MinDuration := ini.ReadInteger(sUserPrefsSection, 'Input11MinDuration', 2);
      Input12MinDuration := ini.ReadInteger(sUserPrefsSection, 'Input12MinDuration', 2);
      {
      Input13MinDuration := ini.ReadInteger(sUserPrefsSection, 'Input13MinDuration', 2);
      Input14MinDuration := ini.ReadInteger(sUserPrefsSection, 'Input14MinDuration', 2);
      Input15MinDuration := ini.ReadInteger(sUserPrefsSection, 'Input15MinDuration', 2);
      Input16MinDuration := ini.ReadInteger(sUserPrefsSection, 'Input16MinDuration', 2);
      }
      Input0Label := ini.ReadString(sUserPrefsSection, 'Input0Label', 'Libell_0');
      Input1Label := ini.ReadString(sUserPrefsSection, 'Input1Label', 'Libell_1');
      Input2Label := ini.ReadString(sUserPrefsSection, 'Input2Label', 'Libell_2');
      Input3Label := ini.ReadString(sUserPrefsSection, 'Input3Label', 'Libell_3');
      Input4Label := ini.ReadString(sUserPrefsSection, 'Input4Label', 'Libell_4');
      Input5Label := ini.ReadString(sUserPrefsSection, 'Input5Label', 'Libell_5');
      Input6Label := ini.ReadString(sUserPrefsSection, 'Input6Label', 'Libell_6');
      Input7Label := ini.ReadString(sUserPrefsSection, 'Input7Label', 'Libell_7');
      Input8Label := ini.ReadString(sUserPrefsSection, 'Input8Label', 'Libell_8');
      Input9Label := ini.ReadString(sUserPrefsSection, 'Input9Label', 'Libell_9');
      Input10Label := ini.ReadString(sUserPrefsSection, 'Input10Label', 'Libell_10');
      Input11Label := ini.ReadString(sUserPrefsSection, 'Input11Label', 'Libell_11');
      Input12Label := ini.ReadString(sUserPrefsSection, 'Input12Label', 'Libell_12');
      {
      Input13Label := ini.ReadString(sUserPrefsSection, 'Input13Label', 'Libell_13');
      Input14Label := ini.ReadString(sUserPrefsSection, 'Input14Label', 'Libell_14');
      Input15Label := ini.ReadString(sUserPrefsSection, 'Input15Label', 'Libell_15');
      Input16Label := ini.ReadString(sUserPrefsSection, 'Input16Label', 'Libell_16');
      }
      Input0TextColor := ini.ReadInteger(sUserPrefsSection, 'Input0TextColor', clBlack);
      Input1TextColor := ini.ReadInteger(sUserPrefsSection, 'Input1TextColor', clBlack);
      Input2TextColor := ini.ReadInteger(sUserPrefsSection, 'Input2TextColor', clBlack);
      Input3TextColor := ini.ReadInteger(sUserPrefsSection, 'Input3TextColor', clBlack);
      Input4TextColor := ini.ReadInteger(sUserPrefsSection, 'Input4TextColor', clBlack);
      Input5TextColor := ini.ReadInteger(sUserPrefsSection, 'Input5TextColor', clBlack);
      Input6TextColor := ini.ReadInteger(sUserPrefsSection, 'Input6TextColor', clBlack);
      Input7TextColor := ini.ReadInteger(sUserPrefsSection, 'Input7TextColor', clBlack);
      Input8TextColor := ini.ReadInteger(sUserPrefsSection, 'Input8TextColor', clBlack);
      Input9TextColor := ini.ReadInteger(sUserPrefsSection, 'Input9TextColor', clBlack);
      Input10TextColor := ini.ReadInteger(sUserPrefsSection, 'Input10TextColor', clBlack);
      Input11TextColor := ini.ReadInteger(sUserPrefsSection, 'Input11TextColor', clBlack);
      Input12TextColor := ini.ReadInteger(sUserPrefsSection, 'Input12TextColor', clBlack);
      {
      Input13TextColor := ini.ReadInteger(sUserPrefsSection, 'Input13TextColor', clBlack);
      Input14TextColor := ini.ReadInteger(sUserPrefsSection, 'Input14TextColor', clBlack);
      Input15TextColor := ini.ReadInteger(sUserPrefsSection, 'Input15TextColor', clBlack);
      Input16TextColor := ini.ReadInteger(sUserPrefsSection, 'Input16TextColor', clBlack);
      }
      Input0BGColor := ini.ReadInteger(sUserPrefsSection, 'Input0BGColor', clWindow);
      Input1BGColor := ini.ReadInteger(sUserPrefsSection, 'Input1BGColor', clWindow);
      Input2BGColor := ini.ReadInteger(sUserPrefsSection, 'Input2BGColor', clWindow);
      Input3BGColor := ini.ReadInteger(sUserPrefsSection, 'Input3BGColor', clWindow);
      Input4BGColor := ini.ReadInteger(sUserPrefsSection, 'Input4BGColor', clWindow);
      Input5BGColor := ini.ReadInteger(sUserPrefsSection, 'Input5BGColor', clWindow);
      Input6BGColor := ini.ReadInteger(sUserPrefsSection, 'Input6BGColor', clWindow);
      Input7BGColor := ini.ReadInteger(sUserPrefsSection, 'Input7BGColor', clWindow);
      Input8BGColor := ini.ReadInteger(sUserPrefsSection, 'Input8BGColor', clWindow);
      Input9BGColor := ini.ReadInteger(sUserPrefsSection, 'Input9BGColor', clWindow);
      Input10BGColor := ini.ReadInteger(sUserPrefsSection, 'Input10BGColor', clWindow);
      Input11BGColor := ini.ReadInteger(sUserPrefsSection, 'Input11BGColor', clWindow);
      Input12BGColor := ini.ReadInteger(sUserPrefsSection, 'Input12BGColor', clWindow);
      {
      Input13BGColor := ini.ReadInteger(sUserPrefsSection, 'Input13BGColor', clWindow);
      Input14BGColor := ini.ReadInteger(sUserPrefsSection, 'Input14BGColor', clWindow);
      Input15BGColor := ini.ReadInteger(sUserPrefsSection, 'Input15BGColor', clWindow);
      Input16BGColor := ini.ReadInteger(sUserPrefsSection, 'Input16BGColor', clWindow);
      }

      // capture
      CaptureThreadPriority := ini.ReadInteger(sUserPrefsSection, 'CaptureThreadPriority', 3);
      CaptureSaveEdge := ini.ReadBool(sUserPrefsSection, 'CaptureSaveEdge', true);
      CaptureSaveDuration := ini.ReadBool(sUserPrefsSection, 'CaptureSaveDuration', false);
      PortBaseAddressIndex := ini.ReadInteger(sUserPrefsSection, 'PortBaseAddressIndex', 4);

      // report
      ReportSorting := ini.ReadInteger(sUserPrefsSection, 'ReportSorting', 0);
      ReportMainTitle := ini.ReadString(sUserPrefsSection, 'ReportMainTitle', ReportMainTitle);
      ReportSubTitle := ini.ReadString(sUserPrefsSection, 'ReportSubTitle', ReportSubTitle);

    finally
      ini.Free;
    end;
  end;
  Conf_Apply;
end;

procedure Conf_Apply;
begin

  with CaptureConf do
  begin

    // grid column caption
    fmMain.lvEventsList.Columns[0].Caption := GridColumnCaption0;
    fmMain.lvEventsList.Columns[1].Caption := GridColumnCaption1;
    fmMain.lvEventsList.Columns[2].Caption := GridColumnCaption2;
    fmMain.lvEventsList.Columns[3].Caption := GridColumnCaption3;

    // main title
    fmMain.Caption := AppMainTitle;

  end;

end;

procedure Conf_SaveToFile(const sFile: string);
var
  Ini: TInifile;
  i: integer;
begin

  UserPrefs_Save(sFile);
  Conf_SetOpenedConfFile(sFile);
  Conf_SetOpenedConfModified(False);

  exit;


  with CaptureConf do
  begin
    ini := TInifile.Create(sFile);
    try

      // main
      ini.WriteString(sUserPrefsSection, 'AppMainTitle', AppMainTitle);

      // grid columns caption
      ini.WriteString(sUserPrefsSection, 'GridColumnCaption0', GridColumnCaption0);
      ini.WriteString(sUserPrefsSection, 'GridColumnCaption1', GridColumnCaption1);
      ini.WriteString(sUserPrefsSection, 'GridColumnCaption2', GridColumnCaption2);
      ini.WriteString(sUserPrefsSection, 'GridColumnCaption3', GridColumnCaption3);

      // listView columns size
      for i := 0 to pred(fmMain.lvEventsList.Columns.Count) do
      begin
        ini.WriteInteger(
          'GUIControlsSizeAndPos',
          format('EventsList_Column%d_Width', [i]),
          fmMain.lvEventsList.Columns[i].width);
      end;

      // log events colors
      ini.WriteBool(sUserPrefsSection, 'Input0Active', Input0Active);
      ini.WriteBool(sUserPrefsSection, 'Input1Active', Input1Active);
      ini.WriteBool(sUserPrefsSection, 'Input2Active', Input2Active);
      ini.WriteBool(sUserPrefsSection, 'Input3Active', Input3Active);
      ini.WriteBool(sUserPrefsSection, 'Input4Active', Input4Active);
      ini.WriteBool(sUserPrefsSection, 'Input5Active', Input5Active);
      ini.WriteBool(sUserPrefsSection, 'Input6Active', Input6Active);
      ini.WriteBool(sUserPrefsSection, 'Input7Active', Input7Active);
      ini.WriteBool(sUserPrefsSection, 'Input8Active', Input8Active);
      ini.WriteBool(sUserPrefsSection, 'Input9Active', Input9Active);
      ini.WriteBool(sUserPrefsSection, 'Input10Active', Input10Active);
      ini.WriteBool(sUserPrefsSection, 'Input11Active', Input11Active);
      ini.WriteBool(sUserPrefsSection, 'Input12Active', Input12Active);
      {
      ini.WriteBool(sUserPrefsSection, 'Input13Active', Input13Active);
      ini.WriteBool(sUserPrefsSection, 'Input14Active', Input14Active);
      ini.WriteBool(sUserPrefsSection, 'Input15Active', Input15Active);
      ini.WriteBool(sUserPrefsSection, 'Input16Active', Input16Active);
      }
      ini.WriteBool(sUserPrefsSection, 'Input0Invert', Input0Invert);
      ini.WriteBool(sUserPrefsSection, 'Input1Invert', Input1Invert);
      ini.WriteBool(sUserPrefsSection, 'Input2Invert', Input2Invert);
      ini.WriteBool(sUserPrefsSection, 'Input3Invert', Input3Invert);
      ini.WriteBool(sUserPrefsSection, 'Input4Invert', Input4Invert);
      ini.WriteBool(sUserPrefsSection, 'Input5Invert', Input5Invert);
      ini.WriteBool(sUserPrefsSection, 'Input6Invert', Input6Invert);
      ini.WriteBool(sUserPrefsSection, 'Input7Invert', Input7Invert);
      ini.WriteBool(sUserPrefsSection, 'Input8Invert', Input8Invert);
      ini.WriteBool(sUserPrefsSection, 'Input9Invert', Input9Invert);
      ini.WriteBool(sUserPrefsSection, 'Input10Invert', Input10Invert);
      ini.WriteBool(sUserPrefsSection, 'Input11Invert', Input11Invert);
      ini.WriteBool(sUserPrefsSection, 'Input12Invert', Input12Invert);
      {
      ini.WriteBool(sUserPrefsSection, 'Input13Invert', Input13Invert);
      ini.WriteBool(sUserPrefsSection, 'Input14Invert', Input14Invert);
      ini.WriteBool(sUserPrefsSection, 'Input15Invert', Input15Invert);
      ini.WriteBool(sUserPrefsSection, 'Input16Invert', Input16Invert);
      }
      ini.WriteInteger(sUserPrefsSection, 'Input0MinDuration', Input0MinDuration);
      ini.WriteInteger(sUserPrefsSection, 'Input1MinDuration', Input1MinDuration);
      ini.WriteInteger(sUserPrefsSection, 'Input2MinDuration', Input2MinDuration);
      ini.WriteInteger(sUserPrefsSection, 'Input3MinDuration', Input3MinDuration);
      ini.WriteInteger(sUserPrefsSection, 'Input4MinDuration', Input4MinDuration);
      ini.WriteInteger(sUserPrefsSection, 'Input5MinDuration', Input5MinDuration);
      ini.WriteInteger(sUserPrefsSection, 'Input6MinDuration', Input6MinDuration);
      ini.WriteInteger(sUserPrefsSection, 'Input7MinDuration', Input7MinDuration);
      ini.WriteInteger(sUserPrefsSection, 'Input8MinDuration', Input8MinDuration);
      ini.WriteInteger(sUserPrefsSection, 'Input9MinDuration', Input9MinDuration);
      ini.WriteInteger(sUserPrefsSection, 'Input10MinDuration', Input10MinDuration);
      ini.WriteInteger(sUserPrefsSection, 'Input11MinDuration', Input11MinDuration);
      ini.WriteInteger(sUserPrefsSection, 'Input12MinDuration', Input12MinDuration);
      {
      ini.WriteInteger(sUserPrefsSection, 'Input13MinDuration', Input13MinDuration);
      ini.WriteInteger(sUserPrefsSection, 'Input14MinDuration', Input14MinDuration);
      ini.WriteInteger(sUserPrefsSection, 'Input15MinDuration', Input15MinDuration);
      ini.WriteInteger(sUserPrefsSection, 'Input16MinDuration', Input16MinDuration);
      }
      ini.WriteString(sUserPrefsSection, 'Input0Label', Input0Label);
      ini.WriteString(sUserPrefsSection, 'Input1Label', Input1Label);
      ini.WriteString(sUserPrefsSection, 'Input2Label', Input2Label);
      ini.WriteString(sUserPrefsSection, 'Input3Label', Input3Label);
      ini.WriteString(sUserPrefsSection, 'Input4Label', Input4Label);
      ini.WriteString(sUserPrefsSection, 'Input5Label', Input5Label);
      ini.WriteString(sUserPrefsSection, 'Input6Label', Input6Label);
      ini.WriteString(sUserPrefsSection, 'Input7Label', Input7Label);
      ini.WriteString(sUserPrefsSection, 'Input8Label', Input8Label);
      ini.WriteString(sUserPrefsSection, 'Input9Label', Input9Label);
      ini.WriteString(sUserPrefsSection, 'Input10Label', Input10Label);
      ini.WriteString(sUserPrefsSection, 'Input11Label', Input11Label);
      ini.WriteString(sUserPrefsSection, 'Input12Label', Input12Label);
      {
      ini.WriteString(sUserPrefsSection, 'Input13Label', Input13Label);
      ini.WriteString(sUserPrefsSection, 'Input14Label', Input14Label);
      ini.WriteString(sUserPrefsSection, 'Input15Label', Input15Label);
      ini.WriteString(sUserPrefsSection, 'Input16Label', Input16Label);
      }
      ini.WriteInteger(sUserPrefsSection, 'Input0TextColor', Input0TextColor);
      ini.WriteInteger(sUserPrefsSection, 'Input1TextColor', Input1TextColor);
      ini.WriteInteger(sUserPrefsSection, 'Input2TextColor', Input2TextColor);
      ini.WriteInteger(sUserPrefsSection, 'Input3TextColor', Input3TextColor);
      ini.WriteInteger(sUserPrefsSection, 'Input4TextColor', Input4TextColor);
      ini.WriteInteger(sUserPrefsSection, 'Input5TextColor', Input5TextColor);
      ini.WriteInteger(sUserPrefsSection, 'Input6TextColor', Input6TextColor);
      ini.WriteInteger(sUserPrefsSection, 'Input7TextColor', Input7TextColor);
      ini.WriteInteger(sUserPrefsSection, 'Input8TextColor', Input8TextColor);
      ini.WriteInteger(sUserPrefsSection, 'Input9TextColor', Input9TextColor);
      ini.WriteInteger(sUserPrefsSection, 'Input10TextColor', Input10TextColor);
      ini.WriteInteger(sUserPrefsSection, 'Input11TextColor', Input11TextColor);
      ini.WriteInteger(sUserPrefsSection, 'Input12TextColor', Input12TextColor);
      {
      ini.WriteInteger(sUserPrefsSection, 'Input13TextColor', Input13TextColor);
      ini.WriteInteger(sUserPrefsSection, 'Input14TextColor', Input14TextColor);
      ini.WriteInteger(sUserPrefsSection, 'Input15TextColor', Input15TextColor);
      ini.WriteInteger(sUserPrefsSection, 'Input16TextColor', Input16TextColor);
      }
      ini.WriteInteger(sUserPrefsSection, 'Input0BGColor', Input0BGColor);
      ini.WriteInteger(sUserPrefsSection, 'Input1BGColor', Input1BGColor);
      ini.WriteInteger(sUserPrefsSection, 'Input2BGColor', Input2BGColor);
      ini.WriteInteger(sUserPrefsSection, 'Input3BGColor', Input3BGColor);
      ini.WriteInteger(sUserPrefsSection, 'Input4BGColor', Input4BGColor);
      ini.WriteInteger(sUserPrefsSection, 'Input5BGColor', Input5BGColor);
      ini.WriteInteger(sUserPrefsSection, 'Input6BGColor', Input6BGColor);
      ini.WriteInteger(sUserPrefsSection, 'Input7BGColor', Input7BGColor);
      ini.WriteInteger(sUserPrefsSection, 'Input8BGColor', Input8BGColor);
      ini.WriteInteger(sUserPrefsSection, 'Input9BGColor', Input9BGColor);
      ini.WriteInteger(sUserPrefsSection, 'Input10BGColor', Input10BGColor);
      ini.WriteInteger(sUserPrefsSection, 'Input11BGColor', Input11BGColor);
      ini.WriteInteger(sUserPrefsSection, 'Input12BGColor', Input12BGColor);
      {
      ini.WriteInteger(sUserPrefsSection, 'Input13BGColor', Input13BGColor);
      ini.WriteInteger(sUserPrefsSection, 'Input14BGColor', Input14BGColor);
      ini.WriteInteger(sUserPrefsSection, 'Input15BGColor', Input15BGColor);
      ini.WriteInteger(sUserPrefsSection, 'Input16BGColor', Input16BGColor);
      }

      // capture
      ini.WriteInteger(sUserPrefsSection, 'CaptureThreadPriority', CaptureThreadPriority);
      ini.WriteBool(sUserPrefsSection, 'CaptureSaveEdge', CaptureSaveEdge);
      ini.WriteBool(sUserPrefsSection, 'CaptureSaveDuration', CaptureSaveDuration);
      ini.WriteInteger(sUserPrefsSection, 'PortBaseAddressIndex', PortBaseAddressIndex);

      // report
      ini.WriteInteger(sUserPrefsSection, 'ReportSorting', ReportSorting);
      ini.WriteString(sUserPrefsSection, 'ReportMainTitle', ReportMainTitle);
      ini.WriteString(sUserPrefsSection, 'ReportSubTitle', ReportSubTitle);

    finally
      ini.Free;
    end;
  end;
end;

procedure Conf_SetOpenedConfFile(sFile: string);
begin
  ConfOpenedFileName := sFile;
  fmMain.mnuConfSave.Caption :=
    format('Sauver (%s)', [extractFileName(sFile)])
end;

procedure Conf_SetOpenedConfModified(bState: boolean);
begin
  ConfOpenedFileModified := bState;
end;


end.
