unit uDataRead;

interface

uses
  SysUtils,
  frmMain;


procedure Port_GetValidPorts;
procedure Port_SetBaseAddresses;
procedure Port_CheckForBaseAddr;
procedure Port_COMSetBaseAdress(addr: integer);
procedure Port_LPTSetBaseAdress(addr: integer);
procedure Port_JOYSetBaseAdress(addr: integer);  // always the same addr
procedure Data_ReadSetToError(bState: boolean; ErrStr: string);


implementation

uses
  ResStr,
  rmMisc;


procedure Port_GetValidPorts;

  function PortDetected(Addr: word): boolean;
  begin
    // do the job
    result := true;
  end;

begin
  validPorts.LPT1Detected := PortDetected(LPT1PortBaseAddr); // $378; 888d
  validPorts.LPT2Detected := PortDetected(LPT2PortBaseAddr); // $278; 632d
  validPorts.COM1Detected := PortDetected(COM1PortBaseAddr); // $3F8; 1016d
  validPorts.COM2Detected := PortDetected(COM2PortBaseAddr); // $2F8; 760d
  validPorts.COM3Detected := PortDetected(COM3PortBaseAddr); // $3E8; 1000d
  validPorts.COM4Detected := PortDetected(COM4PortBaseAddr); // $2E8; 744d
  validPorts.JOY1Detected := PortDetected(JOY1PortBaseAddr); // $201;
end;

procedure Port_SetBaseAddresses;
begin
  with UserPrefs do begin
    Port_LPTSetBaseAdress(PortLPTToUse);
    Port_COMSetBaseAdress(PortCOMToUse);
    Port_JOYSetBaseAdress(PortJOYToUse);
  end;
end;

procedure Port_CheckForBaseAddr;
var
  Err: boolean;
begin
  if plugin.LPTCanBeUsed then begin
    Err := (UserPrefs.PortLPTToUse <> LPT1PortBaseAddr) and
           (UserPrefs.PortLPTToUse <> LPT2PortBaseAddr);
  end;
  if plugin.COMCanBeUsed then begin
    Err := Err or
           ((UserPrefs.PortCOMToUse <> COM1PortBaseAddr) and
            (UserPrefs.PortCOMToUse <> COM2PortBaseAddr) and
            (UserPrefs.PortCOMToUse <> COM3PortBaseAddr) and
            (UserPrefs.PortCOMToUse <> COM4PortBaseAddr));
  end;
  if plugin.JOYCanBeUsed then begin
    Err := Err or (UserPrefs.PortJOYToUse <> LPT1PortBaseAddr);
  end;

  if Err then begin
    Data_ReadSetToError(true, sErrPortBaseAddrNotSpecified);
    abort;
  end;
end;

procedure Port_LPTSetBaseAdress(addr: integer);
begin
  UserPrefs.PortLPTToUse := addr;
end;

procedure Port_COMSetBaseAdress(addr: integer);
begin
  UserPrefs.PortCOMToUse := addr;
end;

procedure Port_JOYSetBaseAdress(addr: integer);
begin
  UserPrefs.PortJOYToUse := addr;
end;

procedure Data_ReadSetToError(bState: boolean; ErrStr: string);
begin
  if bState then begin
    fmMain.StatusBar1.panels[sbIdxActualStatus].text := ErrStr;
    fmMain.ActCaptureStopExecute(nil);
  end;
end;



end.
