unit uUserPrefs;

interface

uses
  Classes, SysUtils, IniFiles, Graphics, Dialogs, Forms;

type

  TUserPrefs = record

    // log
    LogDurationFormat: integer;
    LogShowGridLines: boolean;
    LogUseColors: boolean;
    LogPrintColors: boolean;
    LogEvent0Active: boolean;
    LogEvent1Active: boolean;
    LogEvent2Active: boolean;
    LogEvent3Active: boolean;
    LogEvent4Active: boolean;
    LogEvent5Active: boolean;
    LogEvent6Active: boolean;
    LogEvent7Active: boolean;
    LogEvent8Active: boolean;
    LogEvent9Active: boolean;
    LogEvent10Active: boolean;
    LogEvent11Active: boolean;
    LogEvent12Active: boolean;
    {
    LogEvent13Active: boolean;
    LogEvent14Active: boolean;
    LogEvent15Active: boolean;
    LogEvent16Active: boolean;
    }
    LogEvent0Invert: boolean;
    LogEvent1Invert: boolean;
    LogEvent2Invert: boolean;
    LogEvent3Invert: boolean;
    LogEvent4Invert: boolean;
    LogEvent5Invert: boolean;
    LogEvent6Invert: boolean;
    LogEvent7Invert: boolean;
    LogEvent8Invert: boolean;
    LogEvent9Invert: boolean;
    LogEvent10Invert: boolean;
    LogEvent11Invert: boolean;
    LogEvent12Invert: boolean;
    {
    LogEvent13Invert: boolean;
    LogEvent14Invert: boolean;
    LogEvent15Invert: boolean;
    LogEvent16Invert: boolean;
    }
    LogEvent0MinDuration: integer;
    LogEvent1MinDuration: integer;
    LogEvent2MinDuration: integer;
    LogEvent3MinDuration: integer;
    LogEvent4MinDuration: integer;
    LogEvent5MinDuration: integer;
    LogEvent6MinDuration: integer;
    LogEvent7MinDuration: integer;
    LogEvent8MinDuration: integer;
    LogEvent9MinDuration: integer;
    LogEvent10MinDuration: integer;
    LogEvent11MinDuration: integer;
    LogEvent12MinDuration: integer;
    {
    LogEvent13MinDuration: integer;
    LogEvent14MinDuration: integer;
    LogEvent15MinDuration: integer;
    LogEvent16MinDuration: integer;
    }
    LogEvent0Label: string;
    LogEvent1Label: string;
    LogEvent2Label: string;
    LogEvent3Label: string;
    LogEvent4Label: string;
    LogEvent5Label: string;
    LogEvent6Label: string;
    LogEvent7Label: string;
    LogEvent8Label: string;
    LogEvent9Label: string;
    LogEvent10Label: string;
    LogEvent11Label: string;
    LogEvent12Label: string;
    {
    LogEvent13Label: string;
    LogEvent14Label: string;
    LogEvent15Label: string;
    LogEvent16Label: string;
    }
    LogEvent0TextColor: TColor;
    LogEvent1TextColor: TColor;
    LogEvent2TextColor: TColor;
    LogEvent3TextColor: TColor;
    LogEvent4TextColor: TColor;
    LogEvent5TextColor: TColor;
    LogEvent6TextColor: TColor;
    LogEvent7TextColor: TColor;
    LogEvent8TextColor: TColor;
    LogEvent9TextColor: TColor;
    LogEvent10TextColor: TColor;
    LogEvent11TextColor: TColor;
    LogEvent12TextColor: TColor;
    {
    LogEvent13TextColor: TColor;
    LogEvent14TextColor: TColor;
    LogEvent15TextColor: TColor;
    LogEvent16TextColor: TColor;
    }
    LogEvent0BGColor: TColor;
    LogEvent1BGColor: TColor;
    LogEvent2BGColor: TColor;
    LogEvent3BGColor: TColor;
    LogEvent4BGColor: TColor;
    LogEvent5BGColor: TColor;
    LogEvent6BGColor: TColor;
    LogEvent7BGColor: TColor;
    LogEvent8BGColor: TColor;
    LogEvent9BGColor: TColor;
    LogEvent10BGColor: TColor;
    LogEvent11BGColor: TColor;
    LogEvent12BGColor: TColor;
    {
    LogEvent13BGColor: TColor;
    LogEvent14BGColor: TColor;
    LogEvent15BGColor: TColor;
    LogEvent16BGColor: TColor;
    }

    // auto save
    LogSaveAutoOnExit: boolean;
    LogSaveAutoOnNewDay: boolean;
    LogSaveAutoOnNewEvent: boolean;
    LogSaveMakeBackup: boolean;

    // capture
    CaptureThreadPriority: integer;
    CaptureRunAtAppStartup: boolean;
    CaptureSaveEdge: boolean;
    CaptureSaveDuration: boolean;
    PortBaseAddressIndex: integer;

    // report
    ReportSorting: integer;
    ReportMainTitle: string;
    ReportSubTitle: string;

    // misc
    MiscRunAppAtWindowsStartup: boolean;
    AppMainTitle: string;
    GridColumnCaption0: string;
    GridColumnCaption1: string;
    GridColumnCaption2: string;
    GridColumnCaption3: string;
    MiscMenuAsXPStyle: boolean;
    MiscShowErrorMessages: boolean;

    // conf file
    ConfLastUsedFile: string;

  end;

procedure UserPrefs_Load(const sFile: string);
procedure UserPrefs_Apply;
procedure UserPrefs_Save(const sFile: string);

var
  UserPrefs: TUserPrefs;

Const
  sUserPrefsSection = 'UserPrefs';

implementation

uses
  rmMisc,
  uResStr, uLog, uCapture,
  frmMain;

procedure UserPrefs_Load(const sFile: string);
var
  Ini: TInifile;
  i: integer;
  val: integer;
begin
  with UserPrefs do
  begin
    ini := TInifile.Create(sFile);
    try

      // main
      AppMainTitle := ini.ReadString(sUserPrefsSection, 'AppMainTitle', 'Acquisition de donnes');

      // conf file
      ConfLastUsedFile := ini.ReadString(sUserPrefsSection, 'ConfLastUsedFile', '');

      // grid columns caption
      GridColumnCaption0 := ini.ReadString(sUserPrefsSection, 'GridColumnCaption0', 'Evenement');
      GridColumnCaption1 := ini.ReadString(sUserPrefsSection, 'GridColumnCaption1', 'TS');
      GridColumnCaption2 := ini.ReadString(sUserPrefsSection, 'GridColumnCaption2', 'Date / Heure');
      GridColumnCaption3 := ini.ReadString(sUserPrefsSection, 'GridColumnCaption3', 'Dure');

      // log apparence
      LogDurationFormat := ini.ReadInteger(sUserPrefsSection, 'LogDurationFormat', 2);
      LogShowGridLines := ini.ReadBool(sUserPrefsSection, 'LogShowGridLines', false);
      LogUseColors := ini.ReadBool(sUserPrefsSection, 'LogUseColors', false);
      LogPrintColors := ini.ReadBool(sUserPrefsSection, 'LogPrintColors', false);

      // listView columns size
      try
        for i := 0 to pred(fmMain.lvEventsList.Columns.Count) do
        begin
          val := ini.ReadInteger(
                   'GUIControlsSizeAndPos',
                   format('EventsList_Column%d_Width', [i]),
                   -1);
          if val > -1 then
            fmMain.lvEventsList.Columns[i].width := val;
        end;
      except
      end;

      // log events colors
      LogEvent0Active := ini.ReadBool(sUserPrefsSection, 'LogEvent0Active', true);
      LogEvent1Active := ini.ReadBool(sUserPrefsSection, 'LogEvent1Active', true);
      LogEvent2Active := ini.ReadBool(sUserPrefsSection, 'LogEvent2Active', true);
      LogEvent3Active := ini.ReadBool(sUserPrefsSection, 'LogEvent3Active', true);
      LogEvent4Active := ini.ReadBool(sUserPrefsSection, 'LogEvent4Active', true);
      LogEvent5Active := ini.ReadBool(sUserPrefsSection, 'LogEvent5Active', true);
      LogEvent6Active := ini.ReadBool(sUserPrefsSection, 'LogEvent6Active', true);
      LogEvent7Active := ini.ReadBool(sUserPrefsSection, 'LogEvent7Active', true);
      LogEvent8Active := ini.ReadBool(sUserPrefsSection, 'LogEvent8Active', true);
      LogEvent9Active := ini.ReadBool(sUserPrefsSection, 'LogEvent9Active', true);
      LogEvent10Active := ini.ReadBool(sUserPrefsSection, 'LogEvent10Active', true);
      LogEvent11Active := ini.ReadBool(sUserPrefsSection, 'LogEvent11Active', true);
      LogEvent12Active := ini.ReadBool(sUserPrefsSection, 'LogEvent12Active', true);
      {
      LogEvent13Active := ini.ReadBool(sUserPrefsSection, 'LogEvent13Active', true);
      LogEvent14Active := ini.ReadBool(sUserPrefsSection, 'LogEvent14Active', true);
      LogEvent15Active := ini.ReadBool(sUserPrefsSection, 'LogEvent15Active', true);
      LogEvent16Active := ini.ReadBool(sUserPrefsSection, 'LogEvent16Active', true);
      }
      LogEvent0Invert := ini.ReadBool(sUserPrefsSection, 'LogEvent0Invert', false);
      LogEvent1Invert := ini.ReadBool(sUserPrefsSection, 'LogEvent1Invert', false);
      LogEvent2Invert := ini.ReadBool(sUserPrefsSection, 'LogEvent2Invert', false);
      LogEvent3Invert := ini.ReadBool(sUserPrefsSection, 'LogEvent3Invert', false);
      LogEvent4Invert := ini.ReadBool(sUserPrefsSection, 'LogEvent4Invert', false);
      LogEvent5Invert := ini.ReadBool(sUserPrefsSection, 'LogEvent5Invert', false);
      LogEvent6Invert := ini.ReadBool(sUserPrefsSection, 'LogEvent6Invert', false);
      LogEvent7Invert := ini.ReadBool(sUserPrefsSection, 'LogEvent7Invert', false);
      LogEvent8Invert := ini.ReadBool(sUserPrefsSection, 'LogEvent8Invert', false);
      LogEvent9Invert := ini.ReadBool(sUserPrefsSection, 'LogEvent9Invert', false);
      LogEvent10Invert := ini.ReadBool(sUserPrefsSection, 'LogEvent10Invert', false);
      LogEvent11Invert := ini.ReadBool(sUserPrefsSection, 'LogEvent11Invert', false);
      LogEvent12Invert := ini.ReadBool(sUserPrefsSection, 'LogEvent12Invert', false);
      {
      LogEvent13Invert := ini.ReadBool(sUserPrefsSection, 'LogEvent13Invert', false);
      LogEvent14Invert := ini.ReadBool(sUserPrefsSection, 'LogEvent14Invert', false);
      LogEvent15Invert := ini.ReadBool(sUserPrefsSection, 'LogEvent15Invert', false);
      LogEvent16Invert := ini.ReadBool(sUserPrefsSection, 'LogEvent16Invert', false);
      }
      LogEvent0MinDuration := ini.ReadInteger(sUserPrefsSection, 'LogEvent0MinDuration', 2);
      LogEvent1MinDuration := ini.ReadInteger(sUserPrefsSection, 'LogEvent1MinDuration', 2);
      LogEvent2MinDuration := ini.ReadInteger(sUserPrefsSection, 'LogEvent2MinDuration', 2);
      LogEvent3MinDuration := ini.ReadInteger(sUserPrefsSection, 'LogEvent3MinDuration', 2);
      LogEvent4MinDuration := ini.ReadInteger(sUserPrefsSection, 'LogEvent4MinDuration', 2);
      LogEvent5MinDuration := ini.ReadInteger(sUserPrefsSection, 'LogEvent5MinDuration', 2);
      LogEvent6MinDuration := ini.ReadInteger(sUserPrefsSection, 'LogEvent6MinDuration', 2);
      LogEvent7MinDuration := ini.ReadInteger(sUserPrefsSection, 'LogEvent7MinDuration', 2);
      LogEvent8MinDuration := ini.ReadInteger(sUserPrefsSection, 'LogEvent8MinDuration', 2);
      LogEvent9MinDuration := ini.ReadInteger(sUserPrefsSection, 'LogEvent9MinDuration', 2);
      LogEvent10MinDuration := ini.ReadInteger(sUserPrefsSection, 'LogEvent10MinDuration', 2);
      LogEvent11MinDuration := ini.ReadInteger(sUserPrefsSection, 'LogEvent11MinDuration', 2);
      LogEvent12MinDuration := ini.ReadInteger(sUserPrefsSection, 'LogEvent12MinDuration', 2);
      {
      LogEvent13MinDuration := ini.ReadInteger(sUserPrefsSection, 'LogEvent13MinDuration', 2);
      LogEvent14MinDuration := ini.ReadInteger(sUserPrefsSection, 'LogEvent14MinDuration', 2);
      LogEvent15MinDuration := ini.ReadInteger(sUserPrefsSection, 'LogEvent15MinDuration', 2);
      LogEvent16MinDuration := ini.ReadInteger(sUserPrefsSection, 'LogEvent16MinDuration', 2);
      }
      LogEvent0Label := ini.ReadString(sUserPrefsSection, 'LogEvent0Label', 'Libell_0');
      LogEvent1Label := ini.ReadString(sUserPrefsSection, 'LogEvent1Label', 'Libell_1');
      LogEvent2Label := ini.ReadString(sUserPrefsSection, 'LogEvent2Label', 'Libell_2');
      LogEvent3Label := ini.ReadString(sUserPrefsSection, 'LogEvent3Label', 'Libell_3');
      LogEvent4Label := ini.ReadString(sUserPrefsSection, 'LogEvent4Label', 'Libell_4');
      LogEvent5Label := ini.ReadString(sUserPrefsSection, 'LogEvent5Label', 'Libell_5');
      LogEvent6Label := ini.ReadString(sUserPrefsSection, 'LogEvent6Label', 'Libell_6');
      LogEvent7Label := ini.ReadString(sUserPrefsSection, 'LogEvent7Label', 'Libell_7');
      LogEvent8Label := ini.ReadString(sUserPrefsSection, 'LogEvent8Label', 'Libell_8');
      LogEvent9Label := ini.ReadString(sUserPrefsSection, 'LogEvent9Label', 'Libell_9');
      LogEvent10Label := ini.ReadString(sUserPrefsSection, 'LogEvent10Label', 'Libell_10');
      LogEvent11Label := ini.ReadString(sUserPrefsSection, 'LogEvent11Label', 'Libell_11');
      LogEvent12Label := ini.ReadString(sUserPrefsSection, 'LogEvent12Label', 'Libell_12');
      {
      LogEvent13Label := ini.ReadString(sUserPrefsSection, 'LogEvent13Label', 'Libell_13');
      LogEvent14Label := ini.ReadString(sUserPrefsSection, 'LogEvent14Label', 'Libell_14');
      LogEvent15Label := ini.ReadString(sUserPrefsSection, 'LogEvent15Label', 'Libell_15');
      LogEvent16Label := ini.ReadString(sUserPrefsSection, 'LogEvent16Label', 'Libell_16');
      }
      LogEvent0TextColor := ini.ReadInteger(sUserPrefsSection, 'LogEvent0TextColor', clBlack);
      LogEvent1TextColor := ini.ReadInteger(sUserPrefsSection, 'LogEvent1TextColor', clBlack);
      LogEvent2TextColor := ini.ReadInteger(sUserPrefsSection, 'LogEvent2TextColor', clBlack);
      LogEvent3TextColor := ini.ReadInteger(sUserPrefsSection, 'LogEvent3TextColor', clBlack);
      LogEvent4TextColor := ini.ReadInteger(sUserPrefsSection, 'LogEvent4TextColor', clBlack);
      LogEvent5TextColor := ini.ReadInteger(sUserPrefsSection, 'LogEvent5TextColor', clBlack);
      LogEvent6TextColor := ini.ReadInteger(sUserPrefsSection, 'LogEvent6TextColor', clBlack);
      LogEvent7TextColor := ini.ReadInteger(sUserPrefsSection, 'LogEvent7TextColor', clBlack);
      LogEvent8TextColor := ini.ReadInteger(sUserPrefsSection, 'LogEvent8TextColor', clBlack);
      LogEvent9TextColor := ini.ReadInteger(sUserPrefsSection, 'LogEvent9TextColor', clBlack);
      LogEvent10TextColor := ini.ReadInteger(sUserPrefsSection, 'LogEvent10TextColor', clBlack);
      LogEvent11TextColor := ini.ReadInteger(sUserPrefsSection, 'LogEvent11TextColor', clBlack);
      LogEvent12TextColor := ini.ReadInteger(sUserPrefsSection, 'LogEvent12TextColor', clBlack);
      {
      LogEvent13TextColor := ini.ReadInteger(sUserPrefsSection, 'LogEvent13TextColor', clBlack);
      LogEvent14TextColor := ini.ReadInteger(sUserPrefsSection, 'LogEvent14TextColor', clBlack);
      LogEvent15TextColor := ini.ReadInteger(sUserPrefsSection, 'LogEvent15TextColor', clBlack);
      LogEvent16TextColor := ini.ReadInteger(sUserPrefsSection, 'LogEvent16TextColor', clBlack);
      }
      LogEvent0BGColor := ini.ReadInteger(sUserPrefsSection, 'LogEvent0BGColor', clWindow);
      LogEvent1BGColor := ini.ReadInteger(sUserPrefsSection, 'LogEvent1BGColor', clWindow);
      LogEvent2BGColor := ini.ReadInteger(sUserPrefsSection, 'LogEvent2BGColor', clWindow);
      LogEvent3BGColor := ini.ReadInteger(sUserPrefsSection, 'LogEvent3BGColor', clWindow);
      LogEvent4BGColor := ini.ReadInteger(sUserPrefsSection, 'LogEvent4BGColor', clWindow);
      LogEvent5BGColor := ini.ReadInteger(sUserPrefsSection, 'LogEvent5BGColor', clWindow);
      LogEvent6BGColor := ini.ReadInteger(sUserPrefsSection, 'LogEvent6BGColor', clWindow);
      LogEvent7BGColor := ini.ReadInteger(sUserPrefsSection, 'LogEvent7BGColor', clWindow);
      LogEvent8BGColor := ini.ReadInteger(sUserPrefsSection, 'LogEvent8BGColor', clWindow);
      LogEvent9BGColor := ini.ReadInteger(sUserPrefsSection, 'LogEvent9BGColor', clWindow);
      LogEvent10BGColor := ini.ReadInteger(sUserPrefsSection, 'LogEvent10BGColor', clWindow);
      LogEvent11BGColor := ini.ReadInteger(sUserPrefsSection, 'LogEvent11BGColor', clWindow);
      LogEvent12BGColor := ini.ReadInteger(sUserPrefsSection, 'LogEvent12BGColor', clWindow);
      {
      LogEvent13BGColor := ini.ReadInteger(sUserPrefsSection, 'LogEvent13BGColor', clWindow);
      LogEvent14BGColor := ini.ReadInteger(sUserPrefsSection, 'LogEvent14BGColor', clWindow);
      LogEvent15BGColor := ini.ReadInteger(sUserPrefsSection, 'LogEvent15BGColor', clWindow);
      LogEvent16BGColor := ini.ReadInteger(sUserPrefsSection, 'LogEvent16BGColor', clWindow);
      }

      // log save
      LogSaveAutoOnExit := ini.ReadBool(sUserPrefsSection, 'LogSaveAutoOnExit', false);
      LogSaveAutoOnNewDay := ini.ReadBool(sUserPrefsSection, 'LogSaveAutoOnNewDay', false);
      LogSaveAutoOnNewEvent := ini.ReadBool(sUserPrefsSection, 'LogSaveAutoOnNewEvent', false);
      LogSaveMakeBackup := ini.ReadBool(sUserPrefsSection, 'LogSaveMakeBackup', false);

      // capture
      CaptureThreadPriority := ini.ReadInteger(sUserPrefsSection, 'CaptureThreadPriority', 3);
      CaptureRunAtAppStartup := ini.ReadBool(sUserPrefsSection, 'CaptureRunAtAppStartup', false);
      CaptureSaveEdge := ini.ReadBool(sUserPrefsSection, 'CaptureSaveEdge', true);
      CaptureSaveDuration := ini.ReadBool(sUserPrefsSection, 'CaptureSaveDuration', false);
      PortBaseAddressIndex := ini.ReadInteger(sUserPrefsSection, 'PortBaseAddressIndex', 4);

      // report
      ReportSorting := ini.ReadInteger(sUserPrefsSection, 'ReportSorting', 0);
      ReportMainTitle := ini.ReadString(sUserPrefsSection, 'ReportMainTitle', ReportMainTitle);
      ReportSubTitle := ini.ReadString(sUserPrefsSection, 'ReportSubTitle', ReportSubTitle);

      // misc
      MiscRunAppAtWindowsStartup := ini.ReadBool(sUserPrefsSection, 'MiscRunAppAtWindowsStartup', false);
      MiscMenuAsXPStyle := ini.ReadBool(sUserPrefsSection, 'MiscMenuAsXPStyle', true);
      MiscShowErrorMessages := ini.ReadBool(sUserPrefsSection, 'MiscShowErrorMessages', true);

    finally
      ini.Free;
    end;
  end;
  UserPrefs_Apply;
end;

procedure UserPrefs_Apply;
begin
  // refresh duration format in duration column
  Log_RefreshLine(true, true, true, true);
  Log_SetOpenedLogModified(false);

  // run capture at app startup ?
  if AppIsStarting and UserPrefs.CaptureRunAtAppStartup then
    Capture_Start;

  // show grid in main event list ?
  fmMain.lvEventsList.GridLines := UserPrefs.LogShowGridLines;

  // grid column caption
  fmMain.lvEventsList.Columns[0].Caption := UserPrefs.GridColumnCaption0;
  fmMain.lvEventsList.Columns[1].Caption := UserPrefs.GridColumnCaption1;
  fmMain.lvEventsList.Columns[2].Caption := UserPrefs.GridColumnCaption2;
  fmMain.lvEventsList.Columns[3].Caption := UserPrefs.GridColumnCaption3;

  // main title
  //fmMain.Caption := UserPrefs.AppMainTitle;
  Log_SetOpenedLogFile(LogOpenedFileName);

  // use colors to differentiate events (buttons) ?
  with fmMain.lvEventsList do
  begin
    if UserPrefs.LogUseColors then
    begin
      OwnerDraw := true;
      OnDrawItem := fmMain.lvEventsListDrawItem;
      //OnCustomDrawItem := fmMain.lvEventsListCustomDrawItem;
      //OnCustomDrawSubItem := fmMain.lvEventsListCustomDrawSubItem;
    end
    else
    begin
      OwnerDraw := false;
      OnDrawItem := nil;
      //OnCustomDrawItem := nil;
      //OnCustomDrawSubItem := nil;
    end;
    fmMain.lvEventsList.Refresh;
  end;

  // misc
  fmMain.XPMenu1.Active := UserPrefs.MiscMenuAsXPStyle;

  // run App at Windows startup ?
  fmMain.BURunOnStartup1.SetRunOnStartup(
    extractFileName(application.exeName),
    application.exeName,
    false,                                  // RunOnce
    UserPrefs.MiscRunAppAtWindowsStartup);  // Run

end;

procedure UserPrefs_Save(const sFile: string);
var
  Ini: TInifile;
  i: integer;
begin
  with UserPrefs do
  begin
    ini := TInifile.Create(sFile);
    try

      // main
      ini.WriteString(sUserPrefsSection, 'AppMainTitle', AppMainTitle);

      // conf file
      ini.WriteString(sUserPrefsSection, 'ConfLastUsedFile', ConfLastUsedFile);

      // grid columns caption
      ini.WriteString(sUserPrefsSection, 'GridColumnCaption0', GridColumnCaption0);
      ini.WriteString(sUserPrefsSection, 'GridColumnCaption1', GridColumnCaption1);
      ini.WriteString(sUserPrefsSection, 'GridColumnCaption2', GridColumnCaption2);
      ini.WriteString(sUserPrefsSection, 'GridColumnCaption3', GridColumnCaption3);

      // log apparence
      ini.WriteInteger(sUserPrefsSection, 'LogDurationFormat', LogDurationFormat);
      ini.WriteBool(sUserPrefsSection, 'LogShowGridLines', LogShowGridLines);
      ini.WriteBool(sUserPrefsSection, 'LogUseColors', LogUseColors);
      ini.WriteBool(sUserPrefsSection, 'LogPrintColors', LogPrintColors);

      // listView columns size
      for i := 0 to pred(fmMain.lvEventsList.Columns.Count) do
      begin
        ini.WriteInteger(
          'GUIControlsSizeAndPos',
          format('EventsList_Column%d_Width', [i]),
          fmMain.lvEventsList.Columns[i].width);
      end;

      // log events colors
      ini.WriteBool(sUserPrefsSection, 'LogEvent0Active', LogEvent0Active);
      ini.WriteBool(sUserPrefsSection, 'LogEvent1Active', LogEvent1Active);
      ini.WriteBool(sUserPrefsSection, 'LogEvent2Active', LogEvent2Active);
      ini.WriteBool(sUserPrefsSection, 'LogEvent3Active', LogEvent3Active);
      ini.WriteBool(sUserPrefsSection, 'LogEvent4Active', LogEvent4Active);
      ini.WriteBool(sUserPrefsSection, 'LogEvent5Active', LogEvent5Active);
      ini.WriteBool(sUserPrefsSection, 'LogEvent6Active', LogEvent6Active);
      ini.WriteBool(sUserPrefsSection, 'LogEvent7Active', LogEvent7Active);
      ini.WriteBool(sUserPrefsSection, 'LogEvent8Active', LogEvent8Active);
      ini.WriteBool(sUserPrefsSection, 'LogEvent9Active', LogEvent9Active);
      ini.WriteBool(sUserPrefsSection, 'LogEvent10Active', LogEvent10Active);
      ini.WriteBool(sUserPrefsSection, 'LogEvent11Active', LogEvent11Active);
      ini.WriteBool(sUserPrefsSection, 'LogEvent12Active', LogEvent12Active);
      {
      ini.WriteBool(sUserPrefsSection, 'LogEvent13Active', LogEvent13Active);
      ini.WriteBool(sUserPrefsSection, 'LogEvent14Active', LogEvent14Active);
      ini.WriteBool(sUserPrefsSection, 'LogEvent15Active', LogEvent15Active);
      ini.WriteBool(sUserPrefsSection, 'LogEvent16Active', LogEvent16Active);
      }
      ini.WriteBool(sUserPrefsSection, 'LogEvent0Invert', LogEvent0Invert);
      ini.WriteBool(sUserPrefsSection, 'LogEvent1Invert', LogEvent1Invert);
      ini.WriteBool(sUserPrefsSection, 'LogEvent2Invert', LogEvent2Invert);
      ini.WriteBool(sUserPrefsSection, 'LogEvent3Invert', LogEvent3Invert);
      ini.WriteBool(sUserPrefsSection, 'LogEvent4Invert', LogEvent4Invert);
      ini.WriteBool(sUserPrefsSection, 'LogEvent5Invert', LogEvent5Invert);
      ini.WriteBool(sUserPrefsSection, 'LogEvent6Invert', LogEvent6Invert);
      ini.WriteBool(sUserPrefsSection, 'LogEvent7Invert', LogEvent7Invert);
      ini.WriteBool(sUserPrefsSection, 'LogEvent8Invert', LogEvent8Invert);
      ini.WriteBool(sUserPrefsSection, 'LogEvent9Invert', LogEvent9Invert);
      ini.WriteBool(sUserPrefsSection, 'LogEvent10Invert', LogEvent10Invert);
      ini.WriteBool(sUserPrefsSection, 'LogEvent11Invert', LogEvent11Invert);
      ini.WriteBool(sUserPrefsSection, 'LogEvent12Invert', LogEvent12Invert);
      {
      ini.WriteBool(sUserPrefsSection, 'LogEvent13Invert', LogEvent13Invert);
      ini.WriteBool(sUserPrefsSection, 'LogEvent14Invert', LogEvent14Invert);
      ini.WriteBool(sUserPrefsSection, 'LogEvent15Invert', LogEvent15Invert);
      ini.WriteBool(sUserPrefsSection, 'LogEvent16Invert', LogEvent16Invert);
      }
      ini.WriteInteger(sUserPrefsSection, 'LogEvent0MinDuration', LogEvent0MinDuration);
      ini.WriteInteger(sUserPrefsSection, 'LogEvent1MinDuration', LogEvent1MinDuration);
      ini.WriteInteger(sUserPrefsSection, 'LogEvent2MinDuration', LogEvent2MinDuration);
      ini.WriteInteger(sUserPrefsSection, 'LogEvent3MinDuration', LogEvent3MinDuration);
      ini.WriteInteger(sUserPrefsSection, 'LogEvent4MinDuration', LogEvent4MinDuration);
      ini.WriteInteger(sUserPrefsSection, 'LogEvent5MinDuration', LogEvent5MinDuration);
      ini.WriteInteger(sUserPrefsSection, 'LogEvent6MinDuration', LogEvent6MinDuration);
      ini.WriteInteger(sUserPrefsSection, 'LogEvent7MinDuration', LogEvent7MinDuration);
      ini.WriteInteger(sUserPrefsSection, 'LogEvent8MinDuration', LogEvent8MinDuration);
      ini.WriteInteger(sUserPrefsSection, 'LogEvent9MinDuration', LogEvent9MinDuration);
      ini.WriteInteger(sUserPrefsSection, 'LogEvent10MinDuration', LogEvent10MinDuration);
      ini.WriteInteger(sUserPrefsSection, 'LogEvent11MinDuration', LogEvent11MinDuration);
      ini.WriteInteger(sUserPrefsSection, 'LogEvent12MinDuration', LogEvent12MinDuration);
      {
      ini.WriteInteger(sUserPrefsSection, 'LogEvent13MinDuration', LogEvent13MinDuration);
      ini.WriteInteger(sUserPrefsSection, 'LogEvent14MinDuration', LogEvent14MinDuration);
      ini.WriteInteger(sUserPrefsSection, 'LogEvent15MinDuration', LogEvent15MinDuration);
      ini.WriteInteger(sUserPrefsSection, 'LogEvent16MinDuration', LogEvent16MinDuration);
      }
      ini.WriteString(sUserPrefsSection, 'LogEvent0Label', LogEvent0Label);
      ini.WriteString(sUserPrefsSection, 'LogEvent1Label', LogEvent1Label);
      ini.WriteString(sUserPrefsSection, 'LogEvent2Label', LogEvent2Label);
      ini.WriteString(sUserPrefsSection, 'LogEvent3Label', LogEvent3Label);
      ini.WriteString(sUserPrefsSection, 'LogEvent4Label', LogEvent4Label);
      ini.WriteString(sUserPrefsSection, 'LogEvent5Label', LogEvent5Label);
      ini.WriteString(sUserPrefsSection, 'LogEvent6Label', LogEvent6Label);
      ini.WriteString(sUserPrefsSection, 'LogEvent7Label', LogEvent7Label);
      ini.WriteString(sUserPrefsSection, 'LogEvent8Label', LogEvent8Label);
      ini.WriteString(sUserPrefsSection, 'LogEvent9Label', LogEvent9Label);
      ini.WriteString(sUserPrefsSection, 'LogEvent10Label', LogEvent10Label);
      ini.WriteString(sUserPrefsSection, 'LogEvent11Label', LogEvent11Label);
      ini.WriteString(sUserPrefsSection, 'LogEvent12Label', LogEvent12Label);
      {
      ini.WriteString(sUserPrefsSection, 'LogEvent13Label', LogEvent13Label);
      ini.WriteString(sUserPrefsSection, 'LogEvent14Label', LogEvent14Label);
      ini.WriteString(sUserPrefsSection, 'LogEvent15Label', LogEvent15Label);
      ini.WriteString(sUserPrefsSection, 'LogEvent16Label', LogEvent16Label);
      }
      ini.WriteInteger(sUserPrefsSection, 'LogEvent0TextColor', LogEvent0TextColor);
      ini.WriteInteger(sUserPrefsSection, 'LogEvent1TextColor', LogEvent1TextColor);
      ini.WriteInteger(sUserPrefsSection, 'LogEvent2TextColor', LogEvent2TextColor);
      ini.WriteInteger(sUserPrefsSection, 'LogEvent3TextColor', LogEvent3TextColor);
      ini.WriteInteger(sUserPrefsSection, 'LogEvent4TextColor', LogEvent4TextColor);
      ini.WriteInteger(sUserPrefsSection, 'LogEvent5TextColor', LogEvent5TextColor);
      ini.WriteInteger(sUserPrefsSection, 'LogEvent6TextColor', LogEvent6TextColor);
      ini.WriteInteger(sUserPrefsSection, 'LogEvent7TextColor', LogEvent7TextColor);
      ini.WriteInteger(sUserPrefsSection, 'LogEvent8TextColor', LogEvent8TextColor);
      ini.WriteInteger(sUserPrefsSection, 'LogEvent9TextColor', LogEvent9TextColor);
      ini.WriteInteger(sUserPrefsSection, 'LogEvent10TextColor', LogEvent10TextColor);
      ini.WriteInteger(sUserPrefsSection, 'LogEvent11TextColor', LogEvent11TextColor);
      ini.WriteInteger(sUserPrefsSection, 'LogEvent12TextColor', LogEvent12TextColor);
      {
      ini.WriteInteger(sUserPrefsSection, 'LogEvent13TextColor', LogEvent13TextColor);
      ini.WriteInteger(sUserPrefsSection, 'LogEvent14TextColor', LogEvent14TextColor);
      ini.WriteInteger(sUserPrefsSection, 'LogEvent15TextColor', LogEvent15TextColor);
      ini.WriteInteger(sUserPrefsSection, 'LogEvent16TextColor', LogEvent16TextColor);
      }
      ini.WriteInteger(sUserPrefsSection, 'LogEvent0BGColor', LogEvent0BGColor);
      ini.WriteInteger(sUserPrefsSection, 'LogEvent1BGColor', LogEvent1BGColor);
      ini.WriteInteger(sUserPrefsSection, 'LogEvent2BGColor', LogEvent2BGColor);
      ini.WriteInteger(sUserPrefsSection, 'LogEvent3BGColor', LogEvent3BGColor);
      ini.WriteInteger(sUserPrefsSection, 'LogEvent4BGColor', LogEvent4BGColor);
      ini.WriteInteger(sUserPrefsSection, 'LogEvent5BGColor', LogEvent5BGColor);
      ini.WriteInteger(sUserPrefsSection, 'LogEvent6BGColor', LogEvent6BGColor);
      ini.WriteInteger(sUserPrefsSection, 'LogEvent7BGColor', LogEvent7BGColor);
      ini.WriteInteger(sUserPrefsSection, 'LogEvent8BGColor', LogEvent8BGColor);
      ini.WriteInteger(sUserPrefsSection, 'LogEvent9BGColor', LogEvent9BGColor);
      ini.WriteInteger(sUserPrefsSection, 'LogEvent10BGColor', LogEvent10BGColor);
      ini.WriteInteger(sUserPrefsSection, 'LogEvent11BGColor', LogEvent11BGColor);
      ini.WriteInteger(sUserPrefsSection, 'LogEvent12BGColor', LogEvent12BGColor);
      {
      ini.WriteInteger(sUserPrefsSection, 'LogEvent13BGColor', LogEvent13BGColor);
      ini.WriteInteger(sUserPrefsSection, 'LogEvent14BGColor', LogEvent14BGColor);
      ini.WriteInteger(sUserPrefsSection, 'LogEvent15BGColor', LogEvent15BGColor);
      ini.WriteInteger(sUserPrefsSection, 'LogEvent16BGColor', LogEvent16BGColor);
      }

      // log save
      ini.WriteBool(sUserPrefsSection, 'LogSaveAutoOnExit', LogSaveAutoOnExit);
      ini.WriteBool(sUserPrefsSection, 'LogSaveAutoOnNewDay', LogSaveAutoOnNewDay);
      ini.WriteBool(sUserPrefsSection, 'LogSaveAutoOnNewEvent', LogSaveAutoOnNewEvent);
      ini.WriteBool(sUserPrefsSection, 'LogSaveMakeBackup', LogSaveMakeBackup);

      // capture
      ini.WriteInteger(sUserPrefsSection, 'CaptureThreadPriority', CaptureThreadPriority);
      ini.WriteBool(sUserPrefsSection, 'CaptureRunAtAppStartup', CaptureRunAtAppStartup);
      ini.WriteBool(sUserPrefsSection, 'CaptureSaveEdge', CaptureSaveEdge);
      ini.WriteBool(sUserPrefsSection, 'CaptureSaveDuration', CaptureSaveDuration);
      ini.WriteInteger(sUserPrefsSection, 'PortBaseAddressIndex', PortBaseAddressIndex);

      // report
      ini.WriteInteger(sUserPrefsSection, 'ReportSorting', ReportSorting);
      ini.WriteString(sUserPrefsSection, 'ReportMainTitle', ReportMainTitle);
      ini.WriteString(sUserPrefsSection, 'ReportSubTitle', ReportSubTitle);

      // misc
      ini.WriteBool(sUserPrefsSection, 'MiscRunAppAtWindowsStartup', MiscRunAppAtWindowsStartup);
      ini.WriteBool(sUserPrefsSection, 'MiscMenuAsXPStyle', MiscMenuAsXPStyle);
      ini.WriteBool(sUserPrefsSection, 'MiscShowErrorMessages', MiscShowErrorMessages);

    finally
      ini.Free;
    end;
  end;
end;


end.
